TotalRP3_IntendedLocalization = {
	add = function(self, strings)
		for k, v in pairs(strings) do
			self[k] = v
		end
	end
}

local l = TotalRP3_IntendedLocalization

l:add({
	["INSPECTOR_SPOILER_WARNING"]          = "|cffff0000Spoiler warning:|r This module can show TRP3:Extended item and quest data that is normally not visible to the player.|nUse it carefully when exploring other people's creations.",
	["INSPECTOR_INSPECT_ITEM"]             = "|cffddddddCTRL+|r|TInterface\\tutorialframe\\ui-tutorial-frame:24:16:0:0:512:512:0:72:212:320|t on an item in your bag",
	["INSPECTOR_INSPECT_CAMPAIGN"]         = "Inspect active campaign",
	["OR"]                                 = "or",
	["INSPECTOR_VARIABLES_DESCRIPTION"]    = "|cffff0000DO NOT ABUSE|r the debugger to initialize items! Create a proper workflow instead.",
	["INSPECTOR_VARIABLES_ADD"]            = "Add Variable...",
	["INSPECTOR_TRACKER_DESCRIPTION"]      = "|Tinterface\\dialogframe\\ui-dialog-icon-alertnew:16:16:0:0|t Item workflows are only listed if they are capabale of changing the item's state.|nWorkflows invoked by the 'Run Workflow' effect are not listed.",
	["BUTTON_LABEL_CLEAR"]                 = "Clear",
	["BUTTON_ETRACE_DESCRIPTION"]          = "The |cff00ff00/eventtrace|r macro shows a live log of triggered game events.|nYou can use this tool to find suitable events for your campaign.",
	["INSPECTOR_CAPTURES_DESCRIPTION"]     = "Click on a capture on the left side to see its variables at execution time.",
	["BUTTON_LABEL_OKAY"]                  = "Ok",
	["BUTTON_LABEL_CANCEL"]                = "Cancel",
	["LABEL_VARIABLE"]                     = "Variable",
	["LABEL_VALUE"]                        = "Value",
	["LABEL_TIME"]                         = "Time",
	["LABEL_WORKFLOW"]                     = "Workflow",
	["LABEL_WARNING"]                      = "Warning",
	["LABEL_OBJECT"]                       = "Object",
	["LABEL_OWNER"]                        = "Owner",
	["LABEL_EXPRESSION"]                   = "Expression",
	["LABEL_CAPTURE"]                      = "Capture",
	["CAPTURE_EFFECT_DESCRIPTION"]         = "All workflow variables defined until this point are captured automatically.|nYou can add more evaluated values using below buttons.",
	["CAPTURE_EFFECT_ADD_OPERAND_LABEL"]   = "Add dynamic value",
	["CAPTURE_EFFECT_ADD_TAG_TEXT_LABEL"]  = "Add text with tags",
	["CAPTURE_EFFECT_BUTTON_LABEL_CANCEL"] = "Back",
	["CAPTURE_EFFECT_BUTTON_LABEL_OK"]     = "Add >>>",
	["WARN_NO_OBJECT_SCOPE_LABEL"]         = "Object is not defined",
	["WARN_NO_OBJECT_SCOPE_DESC"]          = "In this context, the source \"Object\" points nowhere. This may lead to undesired behavior.|nIf possible, move the workflow to a more appropriate location or set a different source.",
	["WARN_NOT_SAME_ORIGIN_LABEL"]         = "External reference",
	["WARN_NOT_SAME_ORIGIN_DESC"]          = "You're referencing an object that is stored independently. If you share this creation with other players you must share the referenced creation as well.|nConsider storing the referenced object as an inner item.",
	["WARN_NO_FINAL_STEP_LABEL"]           = "Missing final step",
	["WARN_NO_FINAL_STEP_DESC"]            = "The quest has no final step, therefore it will never display as \"completed\".|nAdd a quest step and/or mark one quest step as final.",
	["WARN_UNUSED_WORKFLOW_LABEL"]         = "Unlinked workflow",
	["WARN_UNUSED_WORKFLOW_DESC"]          = "This workflow appears to be unused.|nAdd an action or an event link that triggers this workflow.",
	["WARN_DEBUG_EFFECT_LABEL"]            = "|cffff0000Debugger Effect|r",
	["WARN_DEBUG_EFFECT_DESC"]             = "This effect is a debug effect.|nIt has no observable effect to the player (even if Intended is not installed), so you should remove it after you've finished debugging.",
	["ANALYZER_PREDICATE_N_LEFT_TERM"]     = "Predicate %d left term",
	["ANALYZER_PREDICATE_N_RIGHT_TERM"]    = "Predicate %d right term",
	["ANALYZER_WORKFLOW_S"]                = "Workflow %s",
	["ANALYZER_EFFECT_N"]                  = "Effect %d",
	["ANALYZER_ACTION_S"]                  = "Action %s",
	["ANALYZER_EVENT_S"]                   = "Event %s",
	["ANALYZER_STEP_N"]                    = "Step %d",
	["ANALYZER_OPTION_N"]                  = "Option %d",
	["LABEL_UNNAMED_OBJECT"]               = "(unnamed)",
	["LABEL_NO_ACTIVE_CAMPAIGN"]           = "You have no active campaign.",
	["TAB_OBJECT_DATA"]                    = "Object Data",
	["TAB_WORKFLOWS"]                      = "Workflows",
	["TAB_QUESTS"]                         = "Quests",
	["TAB_WARNINGS"]                       = "Warnings",
	["TAB_CAPTURES"]                       = "Captures",
	["INSPECTOR_VARIABLES_CHANGE_LABEL"]   = "Enter new value for |cffffff80%s|r",
	["INSPECTOR_TRACKER_TT_CALLED_FROM"]   = "|cffffffff%s|r was called from",
	["INSPECTOR_TRACKER_TT_OPEN_DB"]       = "click to open in database",
	["INSPECTOR_TRACKER_DRAFT_WARNING"]    = "The database is opened with another draft.",
	["INSPECTOR_QUESTS_COL_QUEST"]         = "Quest",
	["INSPECTOR_QUESTS_COL_QUEST_ID"]      = "Quest Id",
	["INSPECTOR_QUESTS_COL_CURRENT_STEP"]  = "Current Step",
	["INSPECTOR_QUESTS_TT_STEPS"]          = "Quest steps",
	["INSPECTOR_QUESTS_TT_STEP"]           = "Quest step",
	["INSPECTOR_QUESTS_TT_STEP_S"]         = "Quest step |cffffffff%s|r",
	["INSPECTOR_QUESTS_TT_STEP_DESC"]      = "The |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffGo to Step|r button switches the quest to this step.",
	["INSPECTOR_QUESTS_TT_OBJ_ID"]         = "Objective",
	["INSPECTOR_QUESTS_TT_OBJ_ID_S_S"]     = "Objective |cffffffff%s|r: %s",
	["INSPECTOR_QUESTS_TT_OBJ_STATUS"]     = "Status",
	["INSPECTOR_QUESTS_TT_NO_STEPS"]       = "no steps",
	["INSPECTOR_QUESTS_TT_RESTART"]        = "The |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffStart|r button restarts this quest.",
	["INSPECTOR_QUESTS_TT_UNREVEAL"]       = "The |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffUnreveal|r button hides this quest.",
	["INSPECTOR_QUESTS_TT_OBJ_UNREVEAL"]   = "The |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffUnreveal|r button hides this objective.",
	["INSPECTOR_QUESTS_TT_OBJ_TOGGLE"]     = "The |TInterface\\Buttons\\ui-rotationleft-button-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffToggle|r button switches the objective completion.",
	["INSPECTOR_QUESTS_TT_NOT_REVEALED"]   = "Quest is not revealed",
	["INSPECTOR_QUESTS_TT_START"]          = "The |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffStart|r button starts this quest.",
	["INSPECTOR_QUESTS_TT_NOT_STARTED"]    = "not started",
	["INSPECTOR_QUESTS_TT_NO_CURR_STEP"]   = "none",
	["INSPECTOR_WARNINGS_TT_LOCATION"]     = "Warning location",
	["INSPECTOR_WARNINGS_TT_STACK_IN"]     = "in %s",
	["INSPECTOR_QUESTS_LABEL_SELECT_STEP"] = "Select Step",
	["INSPECTOR_MENU_LABEL"]               = "Creation Inspector",
	["INSPECTOR_TOOLBAR_TEXT"]             = "Debugger",
	["INSPECTOR_TOOLBAR_TT"]               = "Debugging Tools",
	["INSPECTOR_TOOLBAR_TT_DESC"]          = "Click to open the Inspector page",
	["CAPTURES_ID_LABEL"]                  = "Capture point identifier",
	["CAPTURES_ID_DESC"]                   = "This identifier helps you identify the location of the capture",
	["CAPTURES_EXPRESSIONS"]               = "Captured Expressions",
	["CAPTURES_TAGGED_TEXT_LABEL"]         = "Tagged text",
	["CAPTURES_TAGGED_TEXT_TT"]            = "Text with variable tags",
	["CAPTURES_TAGGED_TEXT_DESC"]          = "Enter your text with variable tags here.",
	["CAPTURES_ALL_WORKFLOW_VARS"]         = "|cff8080ffall workflow variables|r",
	["CAPTURES_EFFECT_LABEL"]              = "Capture point",
	["CAPTURES_EFFECT_TT"]                 = "This effect captures all workflow variables defined at this point and adds them to the inspector.|nHas no effect if this creation isn't on the inspector's tracking list.|n|cffff0000Do not forget to remove this effect before sharing this object!|r",
	["CAPTURES_EFFECT_PREVIEW"]            = "|cffffff00Captures all workflow variables into |cff00ff00%s|r",
	["MODULE_DESC"]                        = "A Simple Debugger for Total RP 3 Extended Creations",
	["CAPTURES_ADD_BUTTON_LABEL"]          = "Add capture point",
	["CAPTURES_ADD_BUTTON_DESC"]           = "Add a capture point for debugging.|nThis is a special effect that stores workflow variables and expressions for later analysis in the debug view.",
	["DEBUG_EFFECTS_MENU_CATEGORY"]        = "Debug Effects",
	["AUTO_TRACK_LABEL"]                   = "automatically track active campaign",
	["AUTO_TRACK_TT"]                      = "Automated campaign tracking",
	["AUTO_TRACK_DESC"]                    = "If activated, the currently active campaign is always added to the tracking list.|nThis is useful when you |cffffffff/reload|r a lot during the creation process.",
	["INSPECTOR_OBJECTIVES_NOT_REVEALED"]  = "not revealed",
	["INSPECTOR_OBJECTIVES_REVEALED"]      = "revealed",
	["INSPECTOR_OBJECTIVES_COMPLETE"]      = "complete",
	["INSPECTOR_OBJECTIVES_NO_DESC"]       = "(no description)",
	["INSPECTOR_OBJECTIVES_DELETED"]       = "|cffff0000(deleted)|r",
	["LABEL_SNAPSHOT"]                     = "Snapshot",
	["INSPECTOR_SNAPSHOTS_ADD"]            = "Snapshot...",
	["LABEL_SNAPSHOT_NAME"]                = "Snapshot Name",
	["POPUP_SNAPSHOT_EXISTS"]              = "A snapshot with this name exists already.|n|nOverwrite?",
	["POPUP_SNAPSHOT_APPLY_CONFIRM"]       = "You are about to apply the snapshot |cffffff00%s|r to this object.|n|nExisting variables will be |cffff0000overwritten|r!%s|n|nAre you sure you want to proceed?",
	["POPUP_SNAPSHOT_APPLY_CONFIRM_CAMP"]  = "|n|nCurrent quest progress will be |cffff0000overwritten|r!",
	["INSPECTOR_SNAPSHOTS_TT_APPLY"]       = "The |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffApply|r button applies this snapshot.",
	["INSPECTOR_SNAPSHOTS_TT_DELETE"]      = "The |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffDelete|r button deletes this snapshot.",
	["INSPECTOR_SNAPSHOTS_TT_MORE"]        = "|cffffffffRight+Click|r for more options.",
	["INSPECTOR_SNAPSHOTS_APPLY"]          = "Apply",
	["INSPECTOR_SNAPSHOTS_APPLY_TT"]       = "Replaces current object data with the snapshot.",
	["INSPECTOR_SNAPSHOTS_EXPORT"]         = "Export as string",
	["INSPECTOR_SNAPSHOTS_EXPORT_TT"]      = "Creates an import string out of the snapshot data that you can share with others.|nThis works similar to the \"Quick Export\" in the database.",
	["INSPECTOR_SNAPSHOTS_TO_ITEM"]        = "Create Item",
	["INSPECTOR_SNAPSHOTS_TO_ITEM_TT"]     = "Okay, this is some crazy Gnome shit, so listen up.|nThis will put an item into your bag, that you can use to apply this snapshot. The created item doesn't require Total RP 3: Intended to be installed so you can share it with anyone.",
	["INSPECTOR_SNAPSHOTS_DELETE"]         = "Delete",
	["INSPECTOR_SNAPSHOTS_DELETE_TT"]      = "Deletes the snapshot",
	["POPUP_ADD_SNAPSHOT_DESC"]            = "A |cffffff00snapshot|r is an extract of the current object state (variables and quest progress), that is stored independently.|nThis allows you to reset an object to a previous state.",
	["INSPECTOR_SNAPSHOTS_EXPORT_TITLE"]   = "Snapshot Export",
	["POPUP_ADD_SNAPSHOT_IMPORT_BUTTON"]   = "Import from string",
	["POPUP_ADD_SNAPSHOT_IMPORT_DESC"]     = "Use this option if you want your snapshot data to be imported from a string instead of using the object's current data.",
	["POPUP_ADD_SNAPSHOT_PASTE_STR"]       = "Paste your import string here",
	["POPUP_ADD_SNAPSHOT_INVALID"]         = "Import failed.|nPlease check if the string is complete.",
	["SYNCHRONIZER_MISSING"]               = "The synchronizer item was placed in your bag, but it isn't in the database yet.|nDo you want to import the item data now?|n(This will open the quick import tool.)",

	
})

local locale = GetLocale()

if locale == "deDE" then
	l:add(
		{
			["ANALYZER_ACTION_S"] = "Aktion %s",
			["ANALYZER_EFFECT_N"] = "Effekt %d",
			["ANALYZER_EVENT_S"] = "Spielereignis %s",
			["ANALYZER_OPTION_N"] = "Option %d",
			["ANALYZER_PREDICATE_N_LEFT_TERM"] = "Prädikat %d linke Seite",
			["ANALYZER_PREDICATE_N_RIGHT_TERM"] = "Prädikat %d rechte Seite",
			["ANALYZER_STEP_N"] = "Schritt %d",
			["ANALYZER_WORKFLOW_S"] = "Arbeitsablauf %s",
			["AUTO_TRACK_DESC"] = "Mit dieser Option wird die aktive Kampagne immer vom Objektinspektor verfolgt.|nDas ist nützlich, wenn du während des Entwicklungsprozesses oft das Interface mit |cffffffff/reload|r neu lädst.",
			["AUTO_TRACK_LABEL"] = "aktive Kampagne automatisch verfolgen",
			["AUTO_TRACK_TT"] = "Automatische Kampagnenverfolgung",
			["BUTTON_ETRACE_DESCRIPTION"] = "Das Makro |cff00ff00/eventtrace|r öffnet eine Echtzeitansicht aller ausgelösten Spielereignisse.|nDu kannst dieses Tool verwenden um geeignete Ereignisse für deine Kampagne zu finden.",
			["BUTTON_LABEL_CANCEL"] = "Abbrechen",
			["BUTTON_LABEL_CLEAR"] = "Zurücksetzen",
			["BUTTON_LABEL_OKAY"] = "Ok",
			["CAPTURE_EFFECT_ADD_OPERAND_LABEL"] = "Dynamischen Wert hinzufügen",
			["CAPTURE_EFFECT_ADD_TAG_TEXT_LABEL"] = "Text mit Tags hinzufügen",
			["CAPTURE_EFFECT_BUTTON_LABEL_CANCEL"] = "Zurück",
			["CAPTURE_EFFECT_BUTTON_LABEL_OK"] = "Hinzufügen >>>",
			["CAPTURE_EFFECT_DESCRIPTION"] = "Alle Variablen, die bis zu diesem Zeitpunkt im Arbeitsablauf definiert sind, werden automatisch gelistst.|nMit den Schaltflächen unten kannst du weitere ausgewertete Werte hinzufügen.",
			["CAPTURES_ADD_BUTTON_DESC"] = "Fügt einen Kontrollpunkt zum debuggen hinzu.|nDies ist ein besonderer Effekt, der alle Variablen im Arbeitsablauf zur späteren Analyse im Objektinspektor aufzeichnet.",
			["CAPTURES_ADD_BUTTON_LABEL"] = "Kontrollpunkt hinzufügen",
			["CAPTURES_ALL_WORKFLOW_VARS"] = "|cff8080ffalle Variablen im Arbeitsablauf|r",
			["CAPTURES_EFFECT_LABEL"] = "Kontrollpunkt",
			["CAPTURES_EFFECT_PREVIEW"] = "|cffffff00Speichere alle Arbeitsablauf-Variablen nach |cff00ff00%s|r",
			["CAPTURES_EFFECT_TT"] = "Diese Effekt speichert alle Variablenwerte des Arbeitsablaufs zum Zeitpunkt der Ausführung für die spätere Überprüfung im Inspektor.|nHat keine Auswirkung, wenn diese Kreation nicht beobachtet wird.|n|cffff0000Vergiss nicht diesen Effekt zu entfernen, bevor du deine Kreation mit anderen teilst!|r",
			["CAPTURES_EXPRESSIONS"] = "Ausdrücke unter Beobachtung",
			["CAPTURES_ID_DESC"] = "Dieser Bezeichner hilft dir die Kontrollstelle wiederzufinden",
			["CAPTURES_ID_LABEL"] = "Kontrollpunktbezeichner",
			["CAPTURES_TAGGED_TEXT_DESC"] = "Gib hier deinen Text mit Platzhaltern ein.",
			["CAPTURES_TAGGED_TEXT_LABEL"] = "Text mit Tags",
			["CAPTURES_TAGGED_TEXT_TT"] = "Text mit Platzhaltern (Tags)",
			["DEBUG_EFFECTS_MENU_CATEGORY"] = "Debugger-Effekte",
			["INSPECTOR_CAPTURES_DESCRIPTION"] = "Klicke links auf einen Kontrollpunkt um die Variablenbelegung zum Zeitpunkt der Ausführung zu sehen.",
			["INSPECTOR_INSPECT_CAMPAIGN"] = "Aktive Kampagne beobachten",
			["INSPECTOR_INSPECT_ITEM"] = "|cffddddddSTRG+|r|TInterface\\tutorialframe\\ui-tutorial-frame:24:16:0:0:512:512:0:72:212:320|t auf einen Inventargegenstand",
			["INSPECTOR_MENU_LABEL"] = "Objektinspektor",
			["INSPECTOR_OBJECTIVES_COMPLETE"] = "erfüllt",
			["INSPECTOR_OBJECTIVES_DELETED"] = "|cffff0000(gelöscht)|r",
			["INSPECTOR_OBJECTIVES_NO_DESC"] = "(keine Beschreibung)",
			["INSPECTOR_OBJECTIVES_NOT_REVEALED"] = "nicht enthüllt",
			["INSPECTOR_OBJECTIVES_REVEALED"] = "enthüllt",
			["INSPECTOR_QUESTS_COL_CURRENT_STEP"] = "Momentaner Schritt",
			["INSPECTOR_QUESTS_COL_QUEST"] = "Quest",
			["INSPECTOR_QUESTS_COL_QUEST_ID"] = "Quest Id",
			["INSPECTOR_QUESTS_LABEL_SELECT_STEP"] = "Wähle Schritt",
			["INSPECTOR_QUESTS_TT_NO_CURR_STEP"] = "keiner",
			["INSPECTOR_QUESTS_TT_NO_STEPS"] = "keine Schritte",
			["INSPECTOR_QUESTS_TT_NOT_REVEALED"] = "Quest ist nicht aufgedeckt",
			["INSPECTOR_QUESTS_TT_NOT_STARTED"] = "nicht begonnen",
			["INSPECTOR_QUESTS_TT_OBJ_ID"] = "Questziel",
			["INSPECTOR_QUESTS_TT_OBJ_ID_S_S"] = "Questziel |cffffffff%s|r: %s",
			["INSPECTOR_QUESTS_TT_OBJ_STATUS"] = "Status",
			["INSPECTOR_QUESTS_TT_OBJ_TOGGLE"] = "Mit |TInterface\\Buttons\\ui-rotationleft-button-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffUmschalten|r änderst du den Questzielstatus.",
			["INSPECTOR_QUESTS_TT_OBJ_UNREVEAL"] = "Mit |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffVerbergen|r versteckst du das Questziel.",
			["INSPECTOR_QUESTS_TT_RESTART"] = "Mit |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffStart|r startest du die Quest neu.",
			["INSPECTOR_QUESTS_TT_START"] = "Die Schaltfläche |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffStart|r startet die Quest.",
			["INSPECTOR_QUESTS_TT_STEP"] = "Questschritt",
			["INSPECTOR_QUESTS_TT_STEP_DESC"] = "Mit |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffWechseln|r wechselst du zu diesem Schritt.",
			["INSPECTOR_QUESTS_TT_STEP_S"] = "Questschritt |cffffffff%s|r",
			["INSPECTOR_QUESTS_TT_STEPS"] = "Questschritte",
			["INSPECTOR_QUESTS_TT_UNREVEAL"] = "Mit |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffVerbergen|r setzt du die Quest auf \"nicht aufgedeckt\" zurück.",
			["INSPECTOR_SNAPSHOTS_ADD"] = "Abbild...",
			["INSPECTOR_SNAPSHOTS_APPLY"] = "Anwenden",
			["INSPECTOR_SNAPSHOTS_APPLY_TT"] = "Ersetzt die momentanen Objektdaten durch das Abbild",
			["INSPECTOR_SNAPSHOTS_DELETE"] = "Löschen",
			["INSPECTOR_SNAPSHOTS_DELETE_TT"] = "Löscht das Abbild",
			["INSPECTOR_SNAPSHOTS_EXPORT"] = "Als Importcode exportieren",
			["INSPECTOR_SNAPSHOTS_EXPORT_TITLE"] = "Abbild-Export",
			["INSPECTOR_SNAPSHOTS_EXPORT_TT"] = "Erstellt einen Importcode aus dem Abbild, der mit anderen geteilt werden kann.|nDas funktioniert analog zum \"Schnellexport\" in der Datenbank.",
			["INSPECTOR_SNAPSHOTS_TO_ITEM"] = "Gegenstand erstellen",
			["INSPECTOR_SNAPSHOTS_TO_ITEM_TT"] = "Okay, das ist ganz kranker Gnomenscheiß, also hör' genau zu.|nHiermit legst du einen Gegenstand in dein Inventar, der benutzt werden kann, um dieses Abbild anzuwenden. Der erstellte Gegenstand benötigt kein Total RP 3: Intended, das heißt, du kannst ihn mit jedem teilen.",
			["INSPECTOR_SNAPSHOTS_TT_APPLY"] = "Mit |TInterface\\Buttons\\ui-spellbookicon-nextpage-up:16:16:0:0|t |cffffffffAnwenden|r wendest du dieses Abbild an.",
			["INSPECTOR_SNAPSHOTS_TT_DELETE"] = "Mit |TInterface\\Buttons\\cancelbutton-up:16:16:0:0:16:16:2:14:2:14|t |cffffffffLöschen|r entfernst du dieses Abbild.",
			["INSPECTOR_SNAPSHOTS_TT_MORE"] = "|cffffffffRechtsklicken|r für mehr Optionen.",
			["INSPECTOR_SPOILER_WARNING"] = "|cffff0000Spoilerwarnung:|r Dieses Modul kann Gegenstands- und Questdaten von TRP3:Extended-Objekten anzeigen, die normalerweise nicht sichtbar sind.|nSei vorsichtig, wenn du Kreationen anderer Spieler untersuchst.",
			["INSPECTOR_TOOLBAR_TEXT"] = "Debugger",
			["INSPECTOR_TOOLBAR_TT"] = "Debug-Werkzeuge",
			["INSPECTOR_TOOLBAR_TT_DESC"] = "Klicken um den Objektinspektor anzuzeigen",
			["INSPECTOR_TRACKER_DESCRIPTION"] = "|Tinterface\\dialogframe\\ui-dialog-icon-alertnew:16:16:0:0|t Arbeitsabläufe von Gegenständen werden nur angezeigt, wenn sie dessen Zustand verändern können. Arbeitsabläufe, die mit dem Effekt 'Arbeitsablauf ausführen' aufgerufen werden, sind nicht gelistet.",
			["INSPECTOR_TRACKER_DRAFT_WARNING"] = "In der Datenbank befindet sich ein bestehender Entwurf.",
			["INSPECTOR_TRACKER_TT_CALLED_FROM"] = "|cffffffff%s|r wurde aufgerufen von",
			["INSPECTOR_TRACKER_TT_OPEN_DB"] = "klicken zur Anzeige in der Datenbank",
			["INSPECTOR_VARIABLES_ADD"] = "Neue Variable...",
			["INSPECTOR_VARIABLES_CHANGE_LABEL"] = "Neuen Wert für |cffffff80%s|r eingeben",
			["INSPECTOR_VARIABLES_DESCRIPTION"] = "Der Debugger ist |cffff0000KEIN ERSATZ FÜR ARBEITSABLÄUFE|r. Wenn du Gegenstands-Variablen initialisieren möchtest, erstelle einen entsprechenden Arbeitsablauf.",
			["INSPECTOR_WARNINGS_TT_LOCATION"] = "Stelle der Warnung",
			["INSPECTOR_WARNINGS_TT_STACK_IN"] = "in %s",
			["LABEL_CAPTURE"] = "Kontrollpunkt",
			["LABEL_EXPRESSION"] = "Ausdruck",
			["LABEL_NO_ACTIVE_CAMPAIGN"] = "Du hast keine laufende Kampagne.",
			["LABEL_OBJECT"] = "Objekt",
			["LABEL_OWNER"] = "Besitzer",
			["LABEL_SNAPSHOT"] = "Abbild",
			["LABEL_SNAPSHOT_NAME"] = "Abbild-Name",
			["LABEL_TIME"] = "Zeit",
			["LABEL_UNNAMED_OBJECT"] = "(unbenannt)",
			["LABEL_VALUE"] = "Wert",
			["LABEL_VARIABLE"] = "Variable",
			["LABEL_WARNING"] = "Warnung",
			["LABEL_WORKFLOW"] = "Arbeitsablauf",
			["MODULE_DESC"] = "Ein einfacher Debugger für Total RP 3 Extended-Kreationen",
			["OR"] = "oder",
			["POPUP_ADD_SNAPSHOT_DESC"] = "Ein |cffffff00Abbild|r ist eine Momentaufnahme des Objekts (Variablen und Questfortschritt), welches unabhängig vom Objekt gespeichert wird.|nDamit kannst du ein Objekt in einen früheren Status versetzen.",
			["POPUP_ADD_SNAPSHOT_IMPORT_BUTTON"] = "Von Importcode importieren",
			["POPUP_ADD_SNAPSHOT_IMPORT_DESC"] = "Verwende diese Option um das Abbild mit den Daten aus einem Importcode zu füllen, anstatt der momentanen Objektdaten.",
			["POPUP_ADD_SNAPSHOT_INVALID"] = "Import fehlgeschlagen.|nBitte überprüfe, ob der Importcode vollständig ist.",
			["POPUP_ADD_SNAPSHOT_PASTE_STR"] = "Importcode hier einfügen",
			["POPUP_SNAPSHOT_APPLY_CONFIRM"] = "Du bist dabei, das Abbild |cffffff00%s|r auf dieses Objekt anzuwenden.|n|nBestehende Variablen werden |cffff0000überschrieben|r!%s|n|nBist du sicher, dass du fortfahren möchtest?",
			["POPUP_SNAPSHOT_APPLY_CONFIRM_CAMP"] = "|n|nDer momentane Questfortschritt wird |cffff0000überschrieben|r!",
			["POPUP_SNAPSHOT_EXISTS"] = "Ein Abbild mit diesem Namen existiert bereits.|n|nÜberschreiben?",
			["SYNCHRONIZER_MISSING"] = "Der Synchronisationsgegenstand befindet sich nun in deinem Inventar, aber nicht in der Datenbank.|nMöchtest du die notwendigen Gegenstandsdaten jetzt importieren?|n(Dies öffnet den Objekt-Schnellimport.)",
			["TAB_CAPTURES"] = "Kontrollpunkte",
			["TAB_OBJECT_DATA"] = "Objektdaten",
			["TAB_QUESTS"] = "Quests",
			["TAB_WARNINGS"] = "Warnungen",
			["TAB_WORKFLOWS"] = "Arbeitsabläufe",
			["WARN_DEBUG_EFFECT_DESC"] = "Dieser Effekt ist ein Debugger-Effekt.|nEr hat keine beobachtbare Auswirkung auf den Spieler (selbst wenn Intended nicht installiert ist), deshalb solltest du den Effekt entfernen, nachdem du mit dem Debuggen fertig bist.",
			["WARN_DEBUG_EFFECT_LABEL"] = "|cffff0000Debugger-Effekt|r",
			["WARN_NO_FINAL_STEP_DESC"] = "Diese Quest hat keinen Endschritt, sie wird deshalb niemals als \"beendet\" angezeigt.|nFüge einen Endschritt hinzu oder markiere einen bestehenden Schritt als Endschritt.",
			["WARN_NO_FINAL_STEP_LABEL"] = "Fehlender Endschritt",
			["WARN_NO_OBJECT_SCOPE_DESC"] = "In diesem Kontext gibt es keine \"Objekt\"-Datenquelle. Dies könnte zu nicht beabsichtigtem Verhalten führen.|nFalls anwendbar, platziere den Arbeitsablauf an eine andere Stelle oder ändere die Variablenquelle.",
			["WARN_NO_OBJECT_SCOPE_LABEL"] = "Objekt ist nicht definiert",
			["WARN_NOT_SAME_ORIGIN_DESC"] = "Du beziehst dich auf ein Objekt, das unabhängig gespeichert wird. Wenn du diese Kreation mit anderen teilst, musst du die andere Kreation ebenfalls mitgeben.|nÜberlege, ob du das Objekt stattdessen als inneres Objekt anlegen kannst.",
			["WARN_NOT_SAME_ORIGIN_LABEL"] = "Externer Verweis",
			["WARN_UNUSED_WORKFLOW_DESC"] = "Dieser Arbeitsablauf scheint nicht benutzt zu werden.|nErstelle eine Aktion oder eine Ereignisverknüpfung, die diesen Arbeitsablauf auslöst.",
			["WARN_UNUSED_WORKFLOW_LABEL"] = "Nicht verknüpfter Arbeitsablauf"

		}
	)
end