local addonName = ...

local UISpecialFrames, GetTime = UISpecialFrames, GetTime
local pairs, tostring, strtrim, assert, tinsert, tremove, loadstring, type = pairs, tostring, strtrim, assert, tinsert, tremove, loadstring, type

local TRP3_API, TRP3_DB, L = TRP3_API, TRP3_DB, TotalRP3_IntendedLocalization

local LibDeflate = LibStub:GetLibrary("LibDeflate")

local observation
local tabGroup
local handledContainerFrames = {}
local debuggerFrames = {}
local timer

local storedData

local ICON_PATH               = "interface\\icons\\"

local DEFAULT_ICON_CUTSCENE   = "interface\\icons\\ui_chat"
local DEFAULT_ICON_QUEST      = "interface\\icons\\achievement_quests_completed_06"
local DEFAULT_ICON_CAMPAIGN   = "interface\\icons\\achievement_quests_completed_06"
local DEFAULT_ICON_STEP       = "interface\\gossipframe\\incompletequesticon"
local DEFAULT_ICON_STEP_FINAL = "interface\\raidframe\\readycheck-ready"
local DEFAULT_ICON_DOCUMENT   = "interface\\icons\\inv_inscription_scroll"
local DEFAULT_ICON_ITEM       = "interface\\icons\\temp"

local PAGE_ID_MAIN            = "debuggerMainPage"
local PAGE_ID_LANDING         = "debuggerLandingPage"
local MENU_ID_LANDING         = "main_99_debugger"

local POPUP_ID_ADD_VAR        = "intended_inspector_add_variable"
local POPUP_ID_ADD_SNAPSHOT   = "intended_inspector_add_snapshot"

local DEBUG_CAPTURE_POINT_ID  = "debug_capture_point"

local SNAPSHOT_TYPE_ITEM      = "item"
local SNAPSHOT_TYPE_CAMPAIGN  = "campaign"

local SYNCHRONIZER_ITEM_ID    = "0123456789TRPCS"
local SYNCHRONIZER_IMPORT_CODE= "!1zvBZPnoq4FlL5U5iZ4Zjan9fY4p4GPT0Hajrq6DtNASWwy0uJfvsoPP9I)TFpswM00RhWiRx29zxT7ZUM4EXlIN1d)oP)lIN1pMCsV(dE(PV4LV61lU(YrK4zdGeKjZWOoMS4VXCSMmYSROCPIzMqwygnyrynaIz8SyIILwjzR2rtLIycvMRAoMCSSQSoPqKslQtKErNjd2uvMQ5IYU790hvNW3uNS3)wQuvNqlZAx4xXZcc01j6TmGGKPRK45(Zygz2iK1jkVuOUztkxQ6U3pvuQzLqhZPF)baEM4GX5bYUPhSi)NbgByr(XbNEPEHbD(TVNs3bZKxoj7HoEiKnyv4LtoZjZfa7qFE5TW6c59(5m9K2fDpYdQJBZdDC2(IwBhfCrZDnJQPTyX8kcIgMRQw3Tt9d)(Z641PZrNz0RiiOxRQoHNgmLVMORwp8TmnMkPWGDWKi2McQMbnJcMomILkYyVriVuYl1DzMDdZYMxUAHqtlWTXFKy3EjtPqIXpdI3SQBK3gAHckydjr1jby05D)J7d8q7JJAVc6Gq)knVq5RysoTWxr3WIynl4FJ1nQ5cP9n54uxEx7RVFpliOtBOUZHdmXNNSW)QLJjlAdggSc9)sftPnH(RmtMkY7EKpyLsKgg5q0ASgDALpJrbB8weRg9uz7QLv4E)lX9JPFkOXroC(buAvpfXme5(F8SFaHNq7qXN5lb)k4kDC7xsgttre1wfoE0QRhhsMpB1fHJUEURu7NROTQnDIrJ5lBlIXwxez2AuekKhC8jNECFqQ6FYWbVAyVtW(NJQFhP4pNyQNYyOa)gBtJPZrHFj8aJYN2QCV(dhCQvz9nUomKSBGe(phwdQm(VGk)sCH7mdoZ7e3zZl1j2oi1j3jKFwnS(9l2YrBbUMTd7Xla3Al9wigydlNa2ife28swMFDYBqpaTNrytrns8k(TSI7rBcgvMULPCDn4AfRaeM14iSD6N5L5oJBHuGZaNyBRzRkbt2OBvPXmt24MxN01cHOubMITJMNfhj7pGTyFfmcJ5fLSwOuIDS7mc002YAZ108JCEDZfuYOzUZmAzWQJHNGQb0RGtxxWCLcz2QAJyWVw0ujCagLwS3bJRiatCCZMkMswkQWrddV24OtElDfDvLICtpaCFLIDUZASzMbF0kj3Z5kqUQDmFqFMB5BtIxJu)hINbsr0s7d8Qec4dKjXKt)QzY1yIHaCEOrLOXGF8FY2kgCK7fvYF05F0Xm5QFO38m6o2dioPfwgIAplLVHNACwuz6x)(ZnHU7OMeGEl9rOBdqpISXrMo30I5oBGTs5OjTE4ZIjxI3A2R3RrP3eC3q3)v74Q0vSY8C(32juRgCkkzW96N8qBucXNzHXKpgn(8LV9t1jJoC9i3xMUvkkrJsP9vUq0RcJN9syXqZIpyhVj0gwhDDmQSUEIXkQs6E1wH2zLiJ)1V3GyYsIrORgB0dfIyC5mZ4il4FySbjTvSM357AwqcXujpFRH7uWt)CtOv9Od(RslgKS)FaU((PmudA7o9Uq7)Sqhp75nDg0XX)7"

-- needed for operands
local operandCode = [[local func = function(args)
	return %s;
end;
setfenv(func, {});
return func;]];
local IMPORT_PATTERN = "local %s = %s;";
--

-- this function uses the same serialization mechanics as TRP3 Extended
local function serialize(data)
	local serial = TRP3_API.utils.serial.serialize(data)
	serial = serial:gsub("|", "||")
	serial = AddOn_TotalRP3.Compression.compress(serial, false)
	serial = "!" .. LibDeflate:EncodeForPrint(serial)
	return serial
end

local function deserialize(dataString)
	local encoded, usesLibDeflate = dataString:gsub("^%!", "")
	if usesLibDeflate == 1 then
		dataString = LibDeflate:DecodeForPrint(encoded)
		dataString = AddOn_TotalRP3.Compression.decompress(dataString, false)
	end
	dataString = dataString:gsub("||", "|")
	return TRP3_API.utils.serial.safeDeserialize(dataString)
end

local function getFancyObjectPathFromId(fullId)
	local obj
	local isRoot = true
	local result = {}
	local resultLine
	local color
	local icon
	for id in fullId:gmatch("%S+") do 
		if isRoot then
			obj = TRP3_API.extended.getClass(id)
		else
			obj = (obj.IN and obj.IN[id]) or (obj.QE and obj.QE[id]) or (obj.ST and obj.ST[id])
			if not obj then break end -- dafuq
		end
		resultLine = {id = id}
		if obj.TY == TRP3_DB.types.CAMPAIGN then
			color = "|cfff0f000"
			icon = (obj.BA.IC and ICON_PATH .. obj.BA.IC) or DEFAULT_ICON_CAMPAIGN
		elseif obj.TY == TRP3_DB.types.QUEST then
			color = "|cfff0f000"
			icon = (obj.BA.IC and ICON_PATH .. obj.BA.IC) or DEFAULT_ICON_QUEST
		elseif obj.TY == TRP3_DB.types.QUEST_STEP then
			color = "|cfff0f000"
			icon = DEFAULT_ICON_STEP
		elseif obj.TY == TRP3_DB.types.ITEM then
			color = TRP3_API.inventory.getQualityColorText(obj.BA.QA or 1)
			icon = (obj.BA.IC and ICON_PATH .. obj.BA.IC) or DEFAULT_ICON_ITEM
		elseif obj.TY == TRP3_DB.types.DOCUMENT then
			color = "|cffffffff"
			icon = DEFAULT_ICON_DOCUMENT
		elseif obj.TY == TRP3_DB.types.DIALOG then
			color = "|cffffffff"
			icon = DEFAULT_ICON_CUTSCENE
		end
		resultLine.text = "|T" .. icon .. ":16:16:0:0|t" .. color .. (obj.BA.NA or id) .. "|r"
		tinsert(result, resultLine)
		isRoot = false
	end
	return result
end
	
local analyzer = {
	
	-- run_item_workflow: 2 -> wf id, 3 -> p order self (?) is not handled properly
	
	SHOW_LOOT_EFFECT_ID = "item_loot",
	VAR_OPERAND_EFFECT  = "var_operand",
	
	EFFECTS_WITH_CLASS_ID = { -- their first arg is a class
		dialog_start          = true,
		document_show         = true,
		item_add              = true,
		item_remove           = true,
		quest_start           = true,
		quest_goToStep        = true,
		quest_revealObjective = true,
		quest_markObjDone     = true
	},
	
	OPERANDS_WITH_CLASS_ID = { -- their first arg is a class
		inv_item_count        = true,
		quest_is_step         = true,
		quest_obj             = true,
		quest_obj_current     = true,
		quest_obj_all         = true
	},
	
	OPERANDS_WITH_SCOPE = {
		var_check             = true,
		var_check_n           = true
	},
	
	codes = {
		NO_OBJECT_SCOPE = {
			short = L.WARN_NO_OBJECT_SCOPE_LABEL,
			long = L.WARN_NO_OBJECT_SCOPE_DESC
		},
		NOT_SAME_ORIGIN  = {
			short = L.WARN_NOT_SAME_ORIGIN_LABEL,
			long = L.WARN_NOT_SAME_ORIGIN_DESC
		},
		NO_FINAL_STEP    = {
			short = L.WARN_NO_FINAL_STEP_LABEL,
			long = L.WARN_NO_FINAL_STEP_DESC
		},
		UNUSED_WORKFLOW  = {
			short = L.WARN_UNUSED_WORKFLOW_LABEL,
			long = L.WARN_UNUSED_WORKFLOW_DESC
		},
		DEBUG_EFFECT = {
			short = L.WARN_DEBUG_EFFECT_LABEL,
			long = L.WARN_DEBUG_EFFECT_DESC
		}
	},
	
	InsertNoObjScope = function(self, objectId, ...)
		tinsert(self.data, {
			code = "NO_OBJECT_SCOPE",
			id = objectId,
			locator = {...}
		})
	end,
	
	AnalyzeOperand = function(self, objectId, operand, args, hasObjectScope, ...)
		if self.OPERANDS_WITH_CLASS_ID[operand] then
			self:SameOriginCheck(objectId, args[1], ...)
		end
		-- if not hasObjectScope and args[1] == "o" and self.OPERANDS_WITH_SCOPE[operand] then
			-- self:InsertNoObjScope(objectId, ...)
		-- end
	end,
	
	AnalyzeCondition = function(self, objectId, condition, hasObjectScope, ...)
		local i = 1
		while i <= #condition do
			if condition[i][1].i then
				self:AnalyzeOperand(objectId, condition[i][1].i, condition[i][1].a, hasObjectScope, ..., L.ANALYZER_PREDICATE_N_LEFT_TERM:format((i+1)/2))
			end
			if condition[i][3].i then
				self:AnalyzeOperand(objectId, condition[i][3].i, condition[i][3].a, hasObjectScope, ..., L.ANALYZER_PREDICATE_N_RIGHT_TERM:format((i+1)/2))
			end
			i = i + 2 -- skip logical operand
		end
	end,
	
	SameOriginCheck = function(self, objectId, refObjectId, ...)
		if refObjectId:sub(1, self.rootIdLength) ~= self.rootId then
			tinsert(self.data, {
				code = "NOT_SAME_ORIGIN",
				id = objectId,
				locator = {...}
			})
		end
	end,
	
	RefCountAdd = function(self, objectId, workflowId)
		self.refCount[objectId] = self.refCount[objectId] or {}
		self.refCount[objectId][workflowId] = (self.refCount[objectId][workflowId] or 0) + 1
	end,
	
	AnalyzeRecursively = function(self, object, id, parentHasObjectScope)
	
		local hasObjectScope = object.TY == TRP3_DB.types.CAMPAIGN or object.TY == TRP3_DB.types.QUEST or object.TY == TRP3_DB.types.QUEST_STEP or object.TY == TRP3_DB.types.ITEM or (object.TY == TRP3_DB.types.DOCUMENT and parentHasObjectScope)
		
		local refCount = self.refCount[id]
		if not refCount then
			refCount = {}
			self.refCount[id] = refCount
		end
		
		if object.SC then -- workflows
			for workflowId, workflowData in pairs(object.SC) do
			
				refCount[workflowId] = refCount[workflowId] or 0
				
				if workflowData.ST then
					for stepId, stepData in pairs(workflowData.ST) do
						if stepData.t == TRP3_DB.elementTypes.EFFECT then
						
							if stepData.e[1].id == DEBUG_CAPTURE_POINT_ID then
								tinsert(self.data, {
									code = "DEBUG_EFFECT",
									id = id,
									locator = {L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId)}
								})
							end
						
							if self.EFFECTS_WITH_CLASS_ID[stepData.e[1].id] then
								self:SameOriginCheck(id, stepData.e[1].args[1], L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId))
							elseif stepData.e[1].id == self.SHOW_LOOT_EFFECT_ID then
								local lootSpec = stepData.e[1].args[1][3]
								for _, content in pairs(lootSpec) do
									self:SameOriginCheck(id, content.classID, L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId))
								end
							elseif stepData.e[1].id == self.VAR_OPERAND_EFFECT then -- "dynamic value"
								self:AnalyzeOperand(id, stepData.e[1].args[3], stepData.e[1].args[4], hasObjectScope, L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId))
								-- if not hasObjectScope and stepData.e[1].args[2] == "o" then
									-- self:InsertNoObjScope(id, "Workflow " .. workflowId, "Effect " .. stepId)
								-- end
							end
							
							if stepData.e[1].cond then
								self:AnalyzeCondition(id, stepData.e[1].cond, hasObjectScope, L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId))
							end
							
							-- if stepData.e[1].id == "var_object" then
								-- if not hasObjectScope and stepData.e[1].args[1] == "o" then
									-- self:InsertNoObjScope(id, "Workflow " .. workflowId, "Effect " .. stepId)
								-- end
							-- end
							
							-- if stepData.e[1].id == "item_roll_dice" then
								-- if not hasObjectScope and stepData.e[1].args[3] ~= "" and stepData.e[1].args[3] == "o" then
									-- self:InsertNoObjScope(id, "Workflow " .. workflowId, "Effect " .. stepId)
								-- end
							-- end
							
							-- if stepData.e[1].id == "var_operand" then
								-- if not hasObjectScope and stepData.e[1].args[2] == "o" then
									-- self:InsertNoObjScope(id, "Workflow " .. workflowId, "Effect " .. stepId)
								-- end
							-- end
	
							if stepData.e[1].id == "run_workflow" then
								if stepData.e[1].args[1] == "o" then
									self:RefCountAdd(id, stepData.e[1].args[2])
								end
								if stepData.e[1].args[1] == "c" then
									self:RefCountAdd(self.rootId, stepData.e[1].args[2])
								end
							end
							
							if stepData.e[1].id == "var_prompt" then
								-- if not hasObjectScope and stepData.e[1].args[3] == "o" then
									-- self:InsertNoObjScope(id, "Workflow " .. workflowId, "Effect " .. stepId)
								-- end
								if stepData.e[1].args[4] ~= "" then
									if stepData.e[1].args[5] == "o" then
										self:RefCountAdd(id, stepData.e[1].args[4])
									end
									if stepData.e[1].args[5] == "c" then
										self:RefCountAdd(self.rootId, stepData.e[1].args[4])
									end
								end
							end
						elseif stepData.t == TRP3_DB.elementTypes.CONDITION then
							self:AnalyzeCondition(id, stepData.b[1].cond, hasObjectScope, L.ANALYZER_WORKFLOW_S:format(workflowId), L.ANALYZER_EFFECT_N:format(stepId))
							if stepData.b[1].failWorkflow then
								self:RefCountAdd(id, stepData.b[1].failWorkflow)
							end
						end
					end
				end
			end
		end
		
		if object.US and object.US.SC then
			self:RefCountAdd(id, object.US.SC)
		end
		
		if object.LI then
			for _, workflowId in pairs(object.LI) do
				self:RefCountAdd(id, workflowId)
			end
		end
		
		if object.AC then -- actions
			for i = 1, #object.AC do
				self:RefCountAdd(id, object.AC[i].SC)
				if object.AC[i].CO then
					self:AnalyzeCondition(id, object.AC[i].CO, hasObjectScope, L.ANALYZER_ACTION_S:format(object.AC[i].TY))
				end
			end
		end
		
		if object.HA then -- game events
			for i = 1, #object.HA do
				self:RefCountAdd(id, object.HA[i].SC)
				if object.HA[i].CO then
					self:AnalyzeCondition(id, object.HA[i].CO, hasObjectScope, L.ANALYZER_EVENT_S:format(object.HA[i].EV))
				end
			end
		end
		
		if object.TY == TRP3_DB.types.DOCUMENT then
			if object.PA then -- pages
				for i = 1, #object.PA do
					local text = object.PA[i].TX or ""
					for workflowId in text:gmatch("%{link%*(.-)%*.-%}") do
						self:RefCountAdd(id, workflowId)
						local firstParenIdx = workflowId:find("%(")
						if firstParenIdx then
							self:RefCountAdd(id, workflowId:sub(1, firstParenIdx-1))
						end
					end
				end
			end
		end
		
		if object.TY == TRP3_DB.types.DIALOG and object.DS then
			for i = 1, #object.DS do
				if object.DS[i].WO then
					self:RefCountAdd(id, object.DS[i].WO)
				end
				if object.DS[i].CH then
					for j = 1, #object.DS[i].CH do
						if object.DS[i].CH[j].C then
							self:AnalyzeCondition(id, object.DS[i].CH[j].C, hasObjectScope, L.ANALYZER_STEP_N:format(i), L.ANALYZER_OPTION_N:format(j))
						end
					end
				end
			end
		end
		
		if object.IN then
			for childId, child in pairs(object.IN) do
				self:AnalyzeRecursively(child, id .. " " .. childId, hasObjectScope)
			end
		end
		
		if object.QE then
			for childId, child in pairs(object.QE) do
				self:AnalyzeRecursively(child, id .. " " .. childId, hasObjectScope)
			end
		end
		
		if object.ST and object.TY == TRP3_DB.types.QUEST then
			local hasFinalStep = false
			for childId, child in pairs(object.ST) do
				self:AnalyzeRecursively(child, id .. " " .. childId, hasObjectScope)
				hasFinalStep = hasFinalStep or child.BA.FI
			end
			if not hasFinalStep then
				tinsert(self.data, {
					code = "NO_FINAL_STEP",
					id = id,
					locator = {}
				})
			end
		end
	end,
	
	Analyze = function(self, rootId) -- NOT THREAD SAFE, change it wheNEVER threads become a thing in addon development
		local objectData = TRP3_API.extended.getClass(rootId) or {}
		self.data = {}
		self.rootId = rootId
		self.rootIdLength = #rootId
		self.refCount = {}
		self:AnalyzeRecursively(objectData, rootId, false)
		
		for objectId, refCounts in pairs(self.refCount) do
			for workflowId, count in pairs(refCounts) do
				if count == 0 then
					tinsert(self.data, {
						code = "UNUSED_WORKFLOW",
						id = objectId,
						locator = {workflowId}
					})
				end
			end
		end
		
		for i = 1,#self.data do
			local item = self.data[i]
			item.text = self.codes[item.code].short
			item.path = getFancyObjectPathFromId(item.id)
			item.object = item.path[#item.path].text
		end
		
		return self.data
	end
}

observation = {
	observables = {},
	counter = 0,
	Find = function(self, observable)
		local result = nil
		if type(observable) == "string" then
			for _, o in pairs(self.observables) do
				if o.id == observable then
					result = o
					break
				end
			end
		else
			for _, o in pairs(self.observables) do
				if o.itemData == observable then
					result = o
					break
				end
			end
		end
		if result and TRP3_API.navigation.menu.isMenuRegistered(result.menuId) then
			return result
		end
	end,
	AddTrackedWorkflow = function(self, scriptID, fullId, object)
		local trackerRow
		for _, observable in pairs(self.observables) do
			-- 2 conditions for observe:
			--   (1) object is same or inner of the observable
			--   (2) if obervable is an item it must be equal to observable, i.e. for items only track workflows of the item itself, because no other workflow can change the item data
			if fullId:sub(1, #observable.id) == observable.id and (not observable.itemData or observable.itemData == object) then
				if not trackerRow then
					trackerRow = {
						time = timer:Now(),
						workflow = scriptID,
						fullId = fullId,
						detail = getFancyObjectPathFromId(fullId)
					}
					trackerRow.owner = trackerRow.detail[#trackerRow.detail].text
				end				
				tinsert(observable.tracker, trackerRow)
			end
		end
	end,
	AddCapture = function(self, captureId, fullId, object, variables)
		local timestamp
		for _, observable in pairs(self.observables) do
			-- 2 conditions for observe:
			--   (1) object is same or inner of the observable
			--   (2) if obervable is an item it must be equal to observable, i.e. for items only track workflows of the item itself, because no other workflow can change the item data
			if fullId:sub(1, #observable.id) == observable.id and (not observable.itemData or observable.itemData == object) then
				timestamp = timestamp or timer:Now()
				tinsert(observable.captures, {
					time = timestamp,
					capture = captureId,
					vars = variables
				})
			end
		end
	end,
	AddMenuItem = function(self, observable)
		self.counter = self.counter + 1
		observable.menuId = MENU_ID_LANDING .. "_item_" .. self.counter
		self.observables[observable.menuId] = observable
		local class
		local color
		local icon
		if observable.itemData then
			class = TRP3_API.extended.getClass(observable.itemData.id)
			color = TRP3_API.inventory.getQualityColorText(class.BA.QA or 1)
			icon = (class.BA.IC and ICON_PATH .. class.BA.IC) or DEFAULT_ICON_ITEM
		else
			class = TRP3_API.extended.getClass(observable.id)
			color = "|cfff0f000"
			icon = (class.BA.IC and ICON_PATH .. class.BA.IC) or DEFAULT_ICON_CAMPAIGN
		end
		
		local menuItem = {
			id = observable.menuId,
			text = color .. (class.BA.NA or L.LABEL_UNNAMED_OBJECT), -- name
			icon = icon,
			onSelected = function()
				self.currentObservable = observable
				self:ValidateObservables()
				tabGroup:SetTabVisible(3, observable.itemData == nil)
				TRP3_API.navigation.page.setPage(PAGE_ID_MAIN)
			end,
			isChildOf = MENU_ID_LANDING,
			closeable = true
		}
		observable.menuItem = menuItem
		TRP3_API.navigation.menu.registerMenu(menuItem)
	end,
	Start = function(self, observableCandidate)
		if observableCandidate then -- item
			local observable = self:Find(observableCandidate)
			if not observable then
				observable = {
					id = observableCandidate.id,
					itemData = observableCandidate,
					tabIndex = 1,
					tracker = {},
					captures = {}
				}
				self:AddMenuItem(observable)
			end
			TRP3_API.navigation.openMainFrame()
			TRP3_API.navigation.menu.selectMenu(observable.menuId)
		else -- active campaign
			local currentCampaignClassId = TRP3_API.quest.getQuestLog().currentCampaign
			if currentCampaignClassId then
				local observable = self:Find(currentCampaignClassId)
				if not observable then
					observable = {
						id = currentCampaignClassId,
						tabIndex = 1,
						tracker = {},
						captures = {}
					}
					self:AddMenuItem(observable)
				end
				TRP3_API.navigation.openMainFrame()
				TRP3_API.navigation.menu.selectMenu(observable.menuId)
			else
				TRP3_API.utils.message.displayMessage(L.LABEL_NO_ACTIVE_CAMPAIGN, TRP3_API.utils.message.type.ALERT_POPUP)
			end
		end
	end,
	StartSilent = function(self)
		local currentCampaignClassId = TRP3_API.quest.getQuestLog().currentCampaign
		if currentCampaignClassId then
			local observable = self:Find(currentCampaignClassId)
			if not observable then
				observable = {
					id = currentCampaignClassId,
					tabIndex = 1,
					tracker = {},
					captures = {}
				}
				self:AddMenuItem(observable)
			end
		end
	end,
	ValidateObservables = function(self)
		if self.currentObservable and not TRP3_API.navigation.menu.isMenuRegistered(self.currentObservable.menuId) then
			self.observables[self.currentObservable.menuId] = nil
			self.currentObservable = nil
		end
		
		for key, observable in pairs(self.observables) do
			if not TRP3_API.navigation.menu.isMenuRegistered(observable.menuId) then
				self.observables[key] = nil
			end
		end
	end,
	RefreshCurrentObservable = function(self, includeAnalyzer)
		if self.currentObservable and TRP3_API.navigation.page.getCurrentPageID() == PAGE_ID_MAIN then -- don't update if not currently visible
			if self.currentObservable.tabIndex ~= 4 or includeAnalyzer then -- the Problems tab might take some time to refresh
				debuggerFrames[self.currentObservable.tabIndex]:Update()
			end
		end
	end,
	SetVariable = function(self, variable, value)
		if self.currentObservable then
			if self.currentObservable.itemData then
				self.currentObservable.itemData.vars = self.currentObservable.itemData.vars or {}
				self.currentObservable.itemData.vars[variable] = value
			else
				local campaignData = TRP3_API.quest.getQuestLog()[self.currentObservable.id]
				campaignData.vars = campaignData.vars or {}
				campaignData.vars[variable] = value
			end
			self:RefreshCurrentObservable()
		end
	end,
	AddSnapshot = function(self, name, importString)
		if self.currentObservable then
			local data = {}
			if importString then
				data = deserialize(importString)
				if data and type(data) == "table" and data.id and data.type and data.data then
					storedData.snapshots[name] = data
					self:RefreshCurrentObservable()
				else
					TRP3_API.utils.message.displayMessage(L.POPUP_ADD_SNAPSHOT_INVALID, TRP3_API.utils.message.type.ALERT_POPUP)
				end
			else
				local snapshotType
				if self.currentObservable.itemData then
					snapshotType = SNAPSHOT_TYPE_ITEM
					TRP3_API.utils.table.copy(data, self.currentObservable.itemData.vars or {}) -- copy only vars if item
				else
					snapshotType = SNAPSHOT_TYPE_CAMPAIGN
					TRP3_API.utils.table.copy(data, TRP3_API.quest.getQuestLog()[self.currentObservable.id] or {}) -- copy all if campaign				
				end
				storedData.snapshots[name] = {
					id    = self.currentObservable.id,
					type = snapshotType,
					data  = data
				}
				self:RefreshCurrentObservable()
			end
		end
	end,
	DeleteSnapshot = function(self, name)
		storedData.snapshots[name] = nil
		self:RefreshCurrentObservable()
	end,
	ApplySnapshot = function(self, name)
		if self.currentObservable then
			local data = {}
			TRP3_API.utils.table.copy(data, storedData.snapshots[name].data or {})
			if self.currentObservable.itemData then
				self.currentObservable.itemData.vars = data
			else
				-- if the target campaign is not active, simply replace the data
				if TRP3_API.quest.getQuestLog().currentCampaign == self.currentObservable.id then
					TRP3_API.quest.deactivateCurrentCampaign(true)
					TRP3_API.quest.getQuestLog()[self.currentObservable.id] = data
					TRP3_API.quest.activateCampaign(self.currentObservable.id)
				else -- campaign is not active, no need to stop/start
					TRP3_API.quest.getQuestLog()[self.currentObservable.id] = data
				end
			end
			self:RefreshCurrentObservable()
		end
	end,
	StartQuest = function(self, questId)
		if self.currentObservable then
			TRP3_API.quest.startQuest(self.currentObservable.id, questId)
		end
	end,
	GoToQuestStep = function(self, questId, stepId)
		if self.currentObservable then
			local questLog = TRP3_API.quest.getQuestLog()[self.currentObservable.id]
			if not questLog or not questLog.QUEST or not questLog.QUEST[questId] then
				TRP3_API.quest.startQuest(self.currentObservable.id, questId)
			end
			if questLog and questLog.QUEST and questLog.QUEST[questId] then
				TRP3_API.quest.goToStep(self.currentObservable.id, questId, stepId)
			end
		end
	end,
	UnrevealQuest = function(self, questId)
		if self.currentObservable then
			local questLog = TRP3_API.quest.getQuestLog()[self.currentObservable.id]
			if questLog and questLog.QUEST then
				if questLog.QUEST[questId] and questLog.QUEST[questId].CS then
					TRP3_API.quest.clearStepHandlers(TRP3_API.extended.getFullID(self.currentObservable.id, questId, questLog.QUEST[questId].CS))
				end
				TRP3_API.quest.clearQuestHandlers(TRP3_API.extended.getFullID(self.currentObservable.id, questId))
				questLog.QUEST[questId] = nil
			end
			TRP3_API.events.fireEvent(TRP3_API.events.CAMPAIGN_REFRESH_LOG) -- unreveal is not part of the API
		end
	end,
	SetObjectiveState = function(self, questId, objectiveId, doToggle)
		if self.currentObservable then
			local questLog = TRP3_API.quest.getQuestLog()[self.currentObservable.id]
			if questLog and questLog.QUEST and questLog.QUEST[questId] then
				if doToggle then
					questLog.QUEST[questId].OB = questLog.QUEST[questId].OB or {}
					local currentState = questLog.QUEST[questId].OB[objectiveId]
					if currentState == true then
						questLog.QUEST[questId].OB[objectiveId] = false -- not part of the API
						TRP3_API.events.fireEvent(TRP3_API.events.CAMPAIGN_REFRESH_LOG)
					elseif currentState == false then
						TRP3_API.quest.markObjectiveDone(self.currentObservable.id, questId, objectiveId)
					else -- currentState == nil
						TRP3_API.quest.revealObjective(self.currentObservable.id, questId, objectiveId)
					end
				elseif questLog.QUEST[questId].OB then
					questLog.QUEST[questId].OB[objectiveId] = nil -- not part of the API
					TRP3_API.events.fireEvent(TRP3_API.events.CAMPAIGN_REFRESH_LOG)
				end
			end
		end
	end,
	ClearCaptures = function(self)
		if self.currentObservable then
			self.currentObservable.captures = {}
			self:RefreshCurrentObservable()
		end
	end,
	TruncateTracker = function(self, index)
		if self.currentObservable then
			local newTracker = {}
			if index then
				for i = index,#self.currentObservable.tracker do
					tinsert(newTracker, self.currentObservable.tracker[i])
				end
			end
			self.currentObservable.tracker = newTracker
			self:RefreshCurrentObservable()
		end
	end,
	TruncateCaptures = function(self, index)
		if self.currentObservable then
			local newCaptures = {}
			if index then
				for i = index,#self.currentObservable.captures do
					tinsert(newCaptures, self.currentObservable.captures[i])
				end
			end
			self.currentObservable.captures = newCaptures
			self:RefreshCurrentObservable()
		end
	end,
	RefreshMenuItems = function(self)
		local class
		local color
		local icon
		for _, observable in pairs(self.observables) do
			if observable.itemData then
				class = TRP3_API.extended.getClass(observable.itemData.id or "")
				color = TRP3_API.inventory.getQualityColorText(class.BA.QA or 1)
				icon = (class.BA.IC and ICON_PATH .. class.BA.IC) or DEFAULT_ICON_ITEM
			else
				class = TRP3_API.extended.getClass(observable.id or "")
				color = "|cfff0f000"
				icon = (class.BA.IC and ICON_PATH .. class.BA.IC) or DEFAULT_ICON_CAMPAIGN
			end
			observable.menuItem.text = color .. (class.BA.NA or L.LABEL_UNNAMED_OBJECT)
			observable.menuItem.icon = icon
		end
		TRP3_API.navigation.menu.rebuildMenu()
		self:RefreshCurrentObservable(true)
	end
}

local hookContainerSlots

local function hookContainerSlot(slot)
	local onDoubleClick = slot:GetScript("OnDoubleClick")
	slot:SetScript("OnDoubleClick", function(...)
		onDoubleClick(...)
		hookContainerSlots()
	end)
	
	local trp3func = slot.trp3func
	slot.trp3func = function(self, button)
		if button == "LeftButton" and IsControlKeyDown() and self.info then
			observation:Start(self.info)
		else
			trp3func(self, button)
		end
	end
end

hookContainerSlots = function()
	for i = 1,#UISpecialFrames do
		local frameName = UISpecialFrames[i]
		if frameName and type(frameName) == "string" then
			if not handledContainerFrames[frameName] and frameName:match("TRP3_Container%d+x%d+_%d+") then
				for j = 1, #_G[frameName].slots do
					hookContainerSlot(_G[frameName].slots[j])
				end
				handledContainerFrames[frameName] = true
			end
		end
	end
end

local function buildUI()
	
	tabGroup = TRP3_API.ui.frame.createTabPanel(TRP3_DebuggerMainPage.tabBar,
		{
			{ L.TAB_OBJECT_DATA , 1, 100 },
			{ L.TAB_WORKFLOWS   , 2, 100 },
			{ L.TAB_QUESTS      , 3, 100 },
			{ L.TAB_WARNINGS    , 4, 100 },
			{ L.TAB_CAPTURES    , 5, 100 }
		},
		function(_, value)
			for i = 1,#debuggerFrames do
				if value == i then
					debuggerFrames[i]:Update()
					debuggerFrames[i]:Show()
				else
					debuggerFrames[i]:Hide()
				end
			end
			observation.currentObservable.tabIndex = value
		end,
		function(callback)
			callback()
		end
	)
		
	TRP3_DebuggerLandingPage.inspectActiveCampaignButton:SetScript("OnClick", function() 
		observation:Start()
	end)
	
	local frame = TRP3_DebuggerMainPage.content.inspector
	frame.addButton:SetScript("OnClick", function() 
		TRP3_API.popup.showPopup(POPUP_ID_ADD_VAR, nil, {})
	end)
	frame.addSnapshotButton:SetScript("OnClick", function()
		local class
		local name = L.LABEL_SNAPSHOT
		if observation.currentObservable.itemData then
			class = TRP3_API.extended.getClass(observation.currentObservable.itemData.id)
		else
			class = TRP3_API.extended.getClass(observation.currentObservable.id)
		end
		if class and class.BA and class.BA.NA then
			name = class.BA.NA
		end
		name = name .. " - " .. timer:DateTime()
		TRP3_API.popup.showPopup(POPUP_ID_ADD_SNAPSHOT, nil, {name})
	end)
	
	frame.table = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 50,
		left = 0,
		height = 370,
		width = 525
	}, {}, {
		{name = "key", type = "text", width = 40, grow = 1, shrink = 1, caption = L.LABEL_VARIABLE, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR") 
			GameTooltip:SetText(row.key) 
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end},
		{name = "value", type = "link", width = 60, grow = 1, shrink = 1, caption = L.LABEL_VALUE, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR") 
			GameTooltip:SetText(row.value, 1, 1, 1, 1) 
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end,
		onMouseUp = function(frame, index) 
			local row = frame:GetDataSource()[index]
			TRP3_API.popup.showTextInputPopup(L.INSPECTOR_VARIABLES_CHANGE_LABEL:format(row.key), function(newValue) 
				observation:SetVariable(row.key, newValue)
			end, function() end, row.value)
		end
		},
		{
			type = "button", width = 16, template = "TRP3_Intended_CancelButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:SetVariable(row.key, nil)
			end
		}
	})
	frame.table.colIndex = 1
	frame.table:ClearAllPoints()
	frame.table:SetPoint("BOTTOMLEFT")
	frame.snapshotTable = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 50,
		left = 0,
		height = 370,
		width = 525
	}, {}, {
		{name = "name", type = "text", width = 40, grow = 1, shrink = 1, caption = L.LABEL_SNAPSHOT,
			onEnter = function(frame, index) 
				local row = frame:GetDataSource()[index]
				GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
				GameTooltip:AddLine(L.LABEL_SNAPSHOT .. " |cffffffff" .. row.name .. "|r")
				GameTooltip:AddLine(" ")
				GameTooltip:AddLine(L.INSPECTOR_SNAPSHOTS_TT_APPLY)
				GameTooltip:AddLine(L.INSPECTOR_SNAPSHOTS_TT_DELETE)
				GameTooltip:AddLine(L.INSPECTOR_SNAPSHOTS_TT_MORE)
				GameTooltip:Show()
			end, onLeave = function(frame, index)
				GameTooltip:Hide()
			end, onMouseUp = function(frame, index, button)
				if button == "RightButton" then
					local snapshotName = frame:GetDataSource()[index].name
					local currentObservable = observation.currentObservable
					local options = {
						{L.INSPECTOR_SNAPSHOTS_APPLY  , "apply", L.INSPECTOR_SNAPSHOTS_APPLY_TT},
						{L.INSPECTOR_SNAPSHOTS_EXPORT , "export", L.INSPECTOR_SNAPSHOTS_EXPORT_TT}
					}
					if not currentObservable.itemData then
						tinsert(options, {L.INSPECTOR_SNAPSHOTS_TO_ITEM, "item", L.INSPECTOR_SNAPSHOTS_TO_ITEM_TT})
					end
					tinsert(options, {L.INSPECTOR_SNAPSHOTS_DELETE, "delete", L.INSPECTOR_SNAPSHOTS_DELETE_TT})
					TRP3_API.ui.listbox.displayDropDown(frame, options, function(value)
						if currentObservable == observation.currentObservable then
							if value == "apply" then
								local text = L.POPUP_SNAPSHOT_APPLY_CONFIRM
								if currentObservable.itemData then
									text = text:format(snapshotName, "")
								else
									text = text:format(snapshotName, L.POPUP_SNAPSHOT_APPLY_CONFIRM_CAMP)
								end
								TRP3_API.popup.showYesNoPopup(text, function()
									if currentObservable == observation.currentObservable then
										observation:ApplySnapshot(snapshotName)
									end
								end)
							elseif value == "export" then
								TRP3_Intended_Export.content.scroll.text:SetText(serialize(storedData.snapshots[snapshotName]));
								TRP3_Intended_Export.content.title:SetText(snapshotName);
								TRP3_Intended_Export:Show();							
							elseif value == "item" then							
								local class = TRP3_API.extended.getClass(currentObservable.id)
								local retCode =TRP3_API.inventory.addItem(nil, SYNCHRONIZER_ITEM_ID, {madeBy = true, vars = {
									campaignName = class.BA.NA or currentObservable.id,
									campaignId   = currentObservable.id,
									snapshotName = snapshotName,
									uid          = TRP3_API.utils.str.id() .. currentObservable.id,
									data         = serialize(storedData.snapshots[snapshotName])
								}}, false)
								
								if retCode == 0 then
									local synchronizerClass = TRP3_API.extended.getClass(SYNCHRONIZER_ITEM_ID)
									if not synchronizerClass or synchronizerClass.missing then
										TRP3_API.popup.showYesNoPopup(L.SYNCHRONIZER_MISSING, function()
											TRP3_API.extended.tools.goToListPage()
											TRP3_API.extended.tools.showFrame()
											TRP3_ToolFrame.list.container.import.content.scroll.text:SetText(SYNCHRONIZER_IMPORT_CODE)
											TRP3_ToolFrame.list.container.import:Show()
										end)
									end
								end
								
							else -- delete
								observation:DeleteSnapshot(snapshotName)
							end							
						end
					end, 0, true)
				end
			end
		},
		{
			type = "button", width = 16, template = "TRP3_Intended_StartButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				local text = L.POPUP_SNAPSHOT_APPLY_CONFIRM
				if observation.currentObservable.itemData then
					text = text:format(row.name, "")
				else
					text = text:format(row.name, L.POPUP_SNAPSHOT_APPLY_CONFIRM_CAMP)
				end
				local currentObservable = observation.currentObservable
				TRP3_API.popup.showYesNoPopup(text, function()
					if currentObservable == observation.currentObservable then
						observation:ApplySnapshot(row.name)
					end
				end)
			end
		},
		{
			type = "button", width = 16, template = "TRP3_Intended_CancelButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:DeleteSnapshot(row.name)
			end
		}
	})
	frame.snapshotTable.colIndex = 1
	frame.snapshotTable:ClearAllPoints()
	frame.snapshotTable:SetPoint("BOTTOMRIGHT")
	frame.Update = function(self)
		local data = {}
		local snapshotData = {}
		if observation.currentObservable then
			local snapshotType
			if observation.currentObservable.itemData then
				if observation.currentObservable.itemData.vars then
					for key, value in pairs(observation.currentObservable.itemData.vars) do
						tinsert(data, {
							key = key,
							value = tostring(value)
						})
					end
				end
				snapshotType = SNAPSHOT_TYPE_ITEM
			else
				local campaignData = TRP3_API.quest.getQuestLog()[observation.currentObservable.id]
				if campaignData and campaignData.vars then
					for key, value in pairs(campaignData.vars) do
						tinsert(data, {
							key = key,
							value = tostring(value)
						})
					end
				end
				snapshotType = SNAPSHOT_TYPE_CAMPAIGN
			end
			
			for sName, sData in pairs(storedData.snapshots) do
				if sData.type == snapshotType then
					tinsert(snapshotData, {
						name = sName
					})
				end
			end
			
		end
		self.table:Update(data)
		self.snapshotTable:Update(snapshotData)
	end
	frame.Resize = function(self, width, height)
		self.table:Resize(width*2/3, height - 50)
		self.snapshotTable:Resize(width/3, height - 50)
	end
	tinsert(debuggerFrames, frame)
	
	frame = TRP3_DebuggerMainPage.content.tracker
	frame.clearButton:SetScript("OnClick", function() 
		observation:TruncateTracker()
	end)
	frame.table = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 55,
		left = 0,
		height = 370,
		width = 530
	}, {}, {
		{name = "time", type = "text", width = 90, caption = L.LABEL_TIME},
		{name = "workflow", type = "text", width = 30, grow = 1, shrink = 1, caption = L.LABEL_WORKFLOW, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR") 
			GameTooltip:SetText(row.workflow) 
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end},
		{name = "owner", type = "text", width = 50, grow = 1, shrink = 1, caption = L.LABEL_OWNER, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			local detail = row.detail
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
			GameTooltip:AddLine(L.INSPECTOR_TRACKER_TT_CALLED_FROM:format(row.workflow))
			GameTooltip:AddLine(" ")
			for i=1,#detail do
				GameTooltip:AddDoubleLine(detail[i].text, detail[i].id)
			end
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(L.INSPECTOR_TRACKER_TT_OPEN_DB)
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end,
		onMouseUp = function(frame, index) 
			local row = frame:GetDataSource()[index]
			if not TRP3_ToolFrame.currentEditor or TRP3_ToolFrame.rootClassID == row.detail[1].id then
				TRP3_API.extended.tools.showFrame()
				TRP3_API.extended.tools.goToPage(row.fullId, true)
			else
				TRP3_API.utils.message.displayMessage(L.INSPECTOR_TRACKER_DRAFT_WARNING, TRP3_API.utils.message.type.ALERT_POPUP)
			end
		end},
		{
			type = "button", width = 16, template = "TRP3_Intended_CollapseButtonTemplate", onClick = function(frame, index)
				observation:TruncateTracker(index)
			end
		}
	})
	frame.Update = function(self)
		if observation.currentObservable then
			self.table:Update(observation.currentObservable.tracker)
		end
	end
	frame.Resize = function(self, width, height)
		self.table:Resize(width, height - 55)
	end
	tinsert(debuggerFrames, frame)
	
	
	frame = TRP3_DebuggerMainPage.content.quests
	frame.stepsTable = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 30,
		left = 0,
		height = 100,
		width = 100
	}, {}, {
		{name = "stepId", type = "text", width = 40, grow = 1, shrink = 1, caption = L.INSPECTOR_QUESTS_TT_STEP, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
			GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_STEP_S:format(row.stepId))
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_STEP_DESC)
			GameTooltip:Show()
		end, onLeave = function(frame, index) 
			GameTooltip:Hide() 
		end},
		{
			type = "button", width = 16, template = "TRP3_Intended_StartButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:GoToQuestStep(row.questId, row.stepId)
			end
		},
	})
	frame.stepsTable.colIndex = 1
	frame.objectivesTable = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 30,
		left = 0,
		height = 100,
		width = 100
	}, {}, {
		{name = "id", type = "text", width = 40, grow = 3, shrink = 1, caption = L.INSPECTOR_QUESTS_TT_OBJ_ID, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
			GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_OBJ_ID_S_S:format(row.id, row.status))
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(row.text)
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_OBJ_UNREVEAL)
			GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_OBJ_TOGGLE)
			GameTooltip:Show()
		end, onLeave = function(frame, index) 
			GameTooltip:Hide() 
		end},
		{name = "status", type = "text", width = 60, grow = 1, shrink = 0, caption = L.INSPECTOR_QUESTS_TT_OBJ_STATUS},
		{
			type = "button", width = 16, template = "TRP3_Intended_ToggleButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:SetObjectiveState(row.questId, row.id, true)
			end
		},
		{
			type = "button", width = 16, template = "TRP3_Intended_CancelButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:SetObjectiveState(row.questId, row.id, false)
			end
		},
	})
	frame.objectivesTable.colIndex = 1
	frame.stepsTable:ClearAllPoints()
	frame.stepsTable:SetPoint("BOTTOMLEFT")
	frame.objectivesTable:ClearAllPoints()
	frame.objectivesTable:SetPoint("BOTTOMRIGHT")
	frame.table = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 0,
		left = 0,
		height = 425,
		width = 530,
		selectMode = "single",
		onUpdate = function(tbl)
			local selectedIndex = tbl:GetSelectedIndex()
			if selectedIndex then
				tbl:GetParent().stepsTable:Update(tbl:GetDataSource()[selectedIndex].availableSteps)
				tbl:GetParent().objectivesTable:Update(tbl:GetDataSource()[selectedIndex].objectives)
				observation.currentObservable.selectedQuestId = tbl:GetDataSource()[selectedIndex].id
			else
				tbl:GetParent().stepsTable:Update({})
				tbl:GetParent().objectivesTable:Update({})
				if observation.currentObservable then
					observation.currentObservable.selectedQuestId = nil
				end
			end
		end
	}, {}, {
		{name = "quest", type = "text", width = 40, grow = 1, shrink = 1, caption = L.INSPECTOR_QUESTS_COL_QUEST},
		{name = "id", type = "text", width = 30, grow = 1, shrink = 1, caption = L.INSPECTOR_QUESTS_COL_QUEST_ID},
		{name = "current", type = "text", width = 30, grow = 1, shrink = 1, caption = L.INSPECTOR_QUESTS_COL_CURRENT_STEP, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
			if row.isRevealed then
				GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_STEPS)
				GameTooltip:AddLine(" ")
				if #row.steps > 0 then
					for i = 1,#row.steps do
						GameTooltip:AddDoubleLine(i, row.steps[i])
					end
				else
					GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_NO_STEPS)
				end
				GameTooltip:AddLine(" ")
				GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_RESTART)
				GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_UNREVEAL)
			else
				GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_NOT_REVEALED)
				GameTooltip:AddLine(L.INSPECTOR_QUESTS_TT_START)
			end
			GameTooltip:Show()
		end, onLeave = function(frame, index) 
			GameTooltip:Hide() 
		end},
		{
			type = "button", width = 16, template = "TRP3_Intended_StartButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:StartQuest(row.id)
			end
		},
		{
			type = "button", width = 16, template = "TRP3_Intended_CancelButtonTemplate", onClick = function(frame, index) 
				local row = frame:GetDataSource()[index]
				observation:UnrevealQuest(row.id)
			end
		}
	})
	frame.table.colIndex = 2
	frame.Update = function(self)
		if observation.currentObservable then
			local campaignId = observation.currentObservable.id
			local questLog = TRP3_API.quest.getQuestLog()[campaignId]
			questLog = (questLog and questLog.QUEST) or {}
			local campaign = TRP3_API.extended.getClass(campaignId) or {}
			local quests = campaign.QE or {}
			
			local allQuests = {}
			for questId, _ in pairs(quests) do
				allQuests[questId] = true
			end
			for questId, _ in pairs(questLog) do
				allQuests[questId] = true
			end
			
			local data = {}
			local questName
			local currentStep
			local isRevealed
			local questLogEntry
			local questSteps
			local color
			
			for questId, _  in pairs(allQuests) do
				
				questData = quests[questId]
				questSteps = questData and questData.ST or {}
				
				if questData then
					questName = "|T" .. ((questData.BA.IC and ICON_PATH .. questData.BA.IC) or DEFAULT_ICON_QUEST) .. ":16:16:0:0|t |cfff0f000" .. (questData.BA.NA or questId) .. "|r"
				else
					questName = "|T" .. DEFAULT_ICON_QUEST .. ":16:16:0:0|t |cffff0000(" .. questId ..")|r"
				end
				
				questLogEntry = questLog[questId]
				
				isRevealed = true
				if not questLogEntry then
					currentStep = L.INSPECTOR_QUESTS_TT_NOT_STARTED
					isRevealed = false
				elseif questLogEntry.FI then
					if questSteps[questLogEntry.CS] then
						currentStep = "|T" .. DEFAULT_ICON_STEP_FINAL .. ":16:16:0:0|t |cfff0f000" .. questLogEntry.CS .. "|r"
					else
						currentStep = "|T" .. DEFAULT_ICON_STEP_FINAL .. ":16:16:0:0|t |cffff0000(" .. questLogEntry.CS .. ")|r"
					end
				elseif questLogEntry.CS then
					if questSteps[questLogEntry.CS] then
						currentStep = "|T" .. DEFAULT_ICON_STEP .. ":16:16:0:0|t |cfff0f000" .. questLogEntry.CS .. "|r"
					else
						currentStep = "|T" .. DEFAULT_ICON_STEP .. ":16:16:0:0|t |cffff0000(" .. questLogEntry.CS .. ")|r"
					end
				else
					currentStep = "|cffff0000" .. L.INSPECTOR_QUESTS_TT_NO_CURR_STEP .. "|r"
				end
				
				local steps = {}
				if questLogEntry then
					if questLogEntry.PS then
						for i = 1,#questLogEntry.PS do
							if questSteps[questLogEntry.PS[i]] then
								tinsert(steps, questLogEntry.PS[i])
							else
								tinsert(steps, "|cffff0000(" .. questLogEntry.PS[i] .. ")|r")
							end
						end
					end
					if questLogEntry.CS then
						if questSteps[questLogEntry.CS] then
							tinsert(steps, questLogEntry.CS)
						else
							tinsert(steps, "|cffff0000(" .. questLogEntry.CS .. ")|r")
						end
					end
				end
				
				local allSteps = {}
				for stepId, _ in pairs(questSteps) do
					tinsert(allSteps, {
						questId = questId,
						stepId = stepId
					})
				end
				
				-- objectives
				local allObjectiveIds = {}
				if questLogEntry and questLogEntry.OB then
					for objectiveId, _ in pairs(questLogEntry.OB) do
						allObjectiveIds[objectiveId] = true
					end
				end
				if questData and questData.OB then
					for objectiveId, _ in pairs(questData.OB) do
						allObjectiveIds[objectiveId] = true
					end
				end
				local allObjectives = {}
				for objectiveId, _ in pairs(allObjectiveIds) do
					local objectiveStatus = L.INSPECTOR_OBJECTIVES_NOT_REVEALED
					local objectiveText = ""
					if questLogEntry and questLogEntry.OB then
						if questLogEntry.OB[objectiveId] == false then
							objectiveStatus = L.INSPECTOR_OBJECTIVES_REVEALED
						elseif questLogEntry.OB[objectiveId] == true then
							objectiveStatus = L.INSPECTOR_OBJECTIVES_COMPLETE
						end
					end
					if questData and questData.OB and questData.OB[objectiveId] then
						objectiveText = questData.OB[objectiveId].TX or L.INSPECTOR_OBJECTIVES_NO_DESC
					else
						objectiveText = L.INSPECTOR_OBJECTIVES_DELETED
					end
					tinsert(allObjectives, {
						questId    = questId,
						id         = objectiveId,
						text       = objectiveText,
						status     = objectiveStatus
					})
				end
				
				tinsert(data, {
					quest          = questName,
					id             = questId,
					current        = currentStep,
					steps          = steps,
					isRevealed     = isRevealed,
					availableSteps = allSteps,
					objectives     = allObjectives,
					selected       = observation.currentObservable.selectedQuestId == questId
				})
			end
			self.table:Update(data)
		end
	end
	frame.Resize = function(self, width, height)
		self.table:Resize(width, height - 100)
		self.stepsTable:Resize(width/2, 100)
		self.objectivesTable:Resize(width/2, 100)
	end
	tinsert(debuggerFrames, frame)
	
	
	frame = TRP3_DebuggerMainPage.content.problems
	frame.table = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 0,
		left = 0,
		height = 425,
		width = 530
	}, {}, {
		{name = "text", type = "text", width = 40, grow = 1, shrink = 1, caption = L.LABEL_WARNING,
			onEnter = function(frame, index) 
				local row = frame:GetDataSource()[index]
				GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
				GameTooltip:AddLine(row.text)
				GameTooltip:AddLine(" ")
				GameTooltip:AddLine(analyzer.codes[row.code].long, 1, 1, 1, 1)
				GameTooltip:Show()
			end,
			onLeave = function(frame, index) GameTooltip:Hide() end
		},
		{name = "object", type = "text", width = 60, grow = 1, shrink = 1, caption = L.LABEL_OBJECT,
			onEnter = function(frame, index) 
				local row = frame:GetDataSource()[index]
				GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
				GameTooltip:AddLine(L.INSPECTOR_WARNINGS_TT_LOCATION)
				GameTooltip:AddLine(" ")
				for i=1,#row.path do
					GameTooltip:AddDoubleLine(row.path[i].text, row.path[i].id)
				end
				if #row.locator > 0 then
					for i = 1,#row.locator do
						GameTooltip:AddLine(L.INSPECTOR_WARNINGS_TT_STACK_IN:format(row.locator[i]))
					end
				end
				
				GameTooltip:Show()
			end,
			onLeave = function(frame, index) GameTooltip:Hide() end
		},
	})
	frame.Update = function(self)
		if observation.currentObservable then
			local data = analyzer:Analyze(observation.currentObservable.id)
			self.table:Update(data)
		end
	end
	frame.Resize = function(self, width, height)
		self.table:Resize(width, height)
	end
	tinsert(debuggerFrames, frame)
	
	
	frame = TRP3_DebuggerMainPage.content.captures
	frame.clearButton:SetScript("OnClick", function() 
		observation:ClearCaptures()
	end)
	frame.variablesTable = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 30,
		left = 0,
		height = 395,
		width = 200
	}, {}, {
		{name = "key", type = "text", width = 40, grow = 1, shrink = 1, caption = L.LABEL_EXPRESSION, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR") 
			GameTooltip:SetText(row.key) 
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end},
		{name = "value", type = "link", width = 60, grow = 1, shrink = 1, caption = L.LABEL_VALUE, onEnter = function(frame, index) 
			local row = frame:GetDataSource()[index]
			GameTooltip:SetOwner(frame, "ANCHOR_CURSOR") 
			GameTooltip:SetText(row.value, 1, 1, 1, 1) 
			GameTooltip:Show()
		end, onLeave = function(frame, index) GameTooltip:Hide() end
		}
	})
	frame.capturesTable = TotalRP3_IntendedUI:CreateTable({
		parent = frame,
		top = 30,
		left = 0,
		height = 395,
		width = 200,
		selectMode = "single",
		onUpdate = function(tbl)
			local selectedIndex = tbl:GetSelectedIndex()
			if selectedIndex then
				tbl:GetParent().variablesTable:Update(tbl:GetDataSource()[selectedIndex].vars)
			else
				tbl:GetParent().variablesTable:Update({})
			end
		end
	}, {}, {
		{name = "time", type = "text", width = 90, caption = L.LABEL_TIME},
		{name = "capture", type = "text", width = 100, grow = 1, shrink = 1, caption = L.LABEL_CAPTURE},
		{
			type = "button", width = 16, template = "TRP3_Intended_CollapseButtonTemplate", onClick = function(frame, index) 
				observation:TruncateCaptures(index)
			end
		}
	})
	frame.variablesTable:SetPoint("TOPLEFT", frame.capturesTable, "TOPRIGHT")
	frame.Update = function(self)
		if observation.currentObservable then
			self.capturesTable:Update(observation.currentObservable.captures)
		end
	end
	frame.Resize = function(self, width, height)
		self.capturesTable:Resize(width/2, height-30)
		self.variablesTable:Resize(width/2, height-30)
	end
	tinsert(debuggerFrames, frame)
	
	
end


local function onInit()
	
	buildUI()
	
	timer = {
		baseTime = tonumber(date("%H"))*60*60 + tonumber(date("%M")) * 60 + tonumber(date("%S")) - GetTime(),
		Now = function(self)
			local t = mod(self.baseTime + GetTime(), 86400)
			local h = math.floor(t/3600)
			local m = math.floor((t - h*3600)/60)
			local s = t - h*3600 - m*60
			return ("%02d:%02d:%06.3f"):format(h, m, s)
		end,
		DateTime = function(self)
			return date("%Y-%m-%d %H:%M")
		end
	}
	
	assert(TRP3_API.inventory.switchContainerByRef, "TRP3_API.inventory.switchContainerByRef is not yet initialized")
	local switchContainerByRef = TRP3_API.inventory.switchContainerByRef
	TRP3_API.inventory.switchContainerByRef = function(...)
		switchContainerByRef(...)
		hookContainerSlots()
	end
	
	assert(TRP3_API.inventory.switchContainerBySlotID, "TRP3_API.inventory.switchContainerBySlotID is not yet initialized")
	local switchContainerBySlotID = TRP3_API.inventory.switchContainerBySlotID
	TRP3_API.inventory.switchContainerBySlotID = function(...)
		switchContainerBySlotID(...)
		hookContainerSlots()
	end
	
	assert(TRP3_API.script.executeClassScript, "TRP3_API.script.executeClassScript is not yet initialized")
	local executeClassScript = TRP3_API.script.executeClassScript
	TRP3_API.script.executeClassScript = function(scriptID, classScripts, args, fullID)
		local retVal = executeClassScript(scriptID, classScripts, args, fullID)
		if scriptID and fullID then
			observation:AddTrackedWorkflow(scriptID, fullID, args and args.object)
			observation:RefreshCurrentObservable()
		end
		return retVal
	end
	
	assert(TRP3_API.script.delayed, "TRP3_API.script.delayed is not yet initialized")
	local delayed = TRP3_API.script.delayed
	TRP3_API.script.delayed = function(delay, func)
		delayed(delay, function() 
			func()
			observation:RefreshCurrentObservable()
		end)
	end
	
	assert(TRP3_API.script.cast, "TRP3_API.script.cast is not yet initialized")
	local cast = TRP3_API.script.cast
	TRP3_API.script.cast = function(delay, func)
		cast(delay, function() 
			func()
			observation:RefreshCurrentObservable()
		end)
	end	
	
	assert(TRP3_API.extended.tools.getEffectOperandLocale, "TRP3_API.extended.tools.getEffectOperandLocale is not yet initialized")
	local getEffectOperandLocale = TRP3_API.extended.tools.getEffectOperandLocale
	TRP3_API.extended.tools.getEffectOperandLocale = function(...)
		local effectMenu = getEffectOperandLocale(...)
		effectMenu[L.DEBUG_EFFECTS_MENU_CATEGORY] = {
			DEBUG_CAPTURE_POINT_ID
		}
		tinsert(effectMenu.order, L.DEBUG_EFFECTS_MENU_CATEGORY)
		return effectMenu
	end
	
	assert(TRP3_API.quest.activateCampaign, "TRP3_API.quest.activateCampaign is not yet initialized")
	local activateCampaign = TRP3_API.quest.activateCampaign
	TRP3_API.quest.activateCampaign = function(...)
		activateCampaign(...)
		if storedData.autoTrack then
			observation:StartSilent()
		end
	end
	
	-- assert(TRP3_API.script.generateAndRunCondition, "TRP3_API.script.generateAndRunCondition is not yet initialized")
	-- local generateAndRunCondition = TRP3_API.script.generateAndRunCondition
	-- TRP3_API.script.generateAndRunCondition = function(conditionStructure, args)
		-- DevTools_Dump(conditionStructure, "conditionStructure")
		-- DevTools_Dump(args, "args")
		-- local outVal = generateAndRunCondition(conditionStructure, args)
		-- return outVal
	-- end
	
end

local function initializePopups()

	local varPopup = TotalRP3_Intended_InspectorAddVariableDialog
	TRP3_API.popup.POPUPS[POPUP_ID_ADD_VAR] = {
		frame = varPopup,
		showMethod = function()
			varPopup.Key:SetText("")
			varPopup.Value:SetText("")
		end
	}
	varPopup.CancelButton:SetScript("OnClick", function() 
		TRP3_API.popup.hidePopups()
	end)
	varPopup.OkButton:SetScript("OnClick", function() 
		local key = strtrim(varPopup.Key:GetText())
		if key ~= "" then
			observation:SetVariable(varPopup.Key:GetText(), varPopup.Value:GetText())
		end
		TRP3_API.popup.hidePopups()
	end)
	
	
	local snapshotPopup = TotalRP3_Intended_InspectorAddSnapshotDialog
	TRP3_API.popup.POPUPS[POPUP_ID_ADD_SNAPSHOT] = {
		frame = snapshotPopup,
		showMethod = function(name)
			snapshotPopup.Name:SetText(name)
			snapshotPopup:SetWindowState(false)
			snapshotPopup.importString.scroll.text:SetText("")
		end
	}
	snapshotPopup.CancelButton:SetScript("OnClick", function() 
		TRP3_API.popup.hidePopups()
	end)
	snapshotPopup.OkButton:SetScript("OnClick", function() 
		local name = strtrim(snapshotPopup.Name:GetText())
		local importString = nil
		if snapshotPopup.importFromStringButton:GetChecked() then
			importString = snapshotPopup.importString.scroll.text:GetText()
		end
		if name ~= "" then
			if storedData.snapshots[name] then
				TRP3_API.popup.showConfirmPopup(L.POPUP_SNAPSHOT_EXISTS, function() 
					observation:AddSnapshot(name, importString)
					TRP3_API.popup.hidePopups()
				end, function()
					TRP3_API.popup.showPopup(POPUP_ID_ADD_SNAPSHOT, nil, {name})
				end)
			else
				observation:AddSnapshot(name, importString)
				TRP3_API.popup.hidePopups()
			end
		else
			TRP3_API.popup.hidePopups()
		end
	end)
	
end

local function onStart()
	
	initializePopups()
	
	TRP3_API.navigation.menu.registerMenu({
		id = MENU_ID_LANDING,
		text = L.INSPECTOR_MENU_LABEL,
		onSelected = function()
			TRP3_API.navigation.page.setPage(PAGE_ID_LANDING)
		end,
	})
	
	TRP3_API.navigation.page.registerPage({
		id = PAGE_ID_LANDING,
		frame = TRP3_DebuggerLandingPage,
		onPagePostShow = function() end
	})
	
	TRP3_API.navigation.page.registerPage({
		id = PAGE_ID_MAIN,
		frame = TRP3_DebuggerMainPage,
		onPagePostShow = function()
			tabGroup:SelectTab(observation.currentObservable.tabIndex)
		end
	})
	
	TRP3_API.events.listenToEvent(TRP3_API.events.NAVIGATION_RESIZED, function(width, height)
		for _, frame in pairs(debuggerFrames) do
			frame:Resize(width-12, height-40)
		end
	end)
	
	-- TRP3_API.quest.EVENT_REFRESH_CAMPAIGN = "EVENT_REFRESH_CAMPAIGN"; happens in TRP3_API.quest.campaignInit, too late!
	TRP3_API.events.listenToEvent("EVENT_REFRESH_CAMPAIGN", function() 
		observation:RefreshCurrentObservable()
	end)
	
	--function TRP3_API.quest.onStart()
	--Events.CAMPAIGN_REFRESH_LOG = "CAMPAIGN_REFRESH_LOG";
	TRP3_API.events.listenToEvent("CAMPAIGN_REFRESH_LOG", function()  -- things like quest start/step/objective
		observation:RefreshCurrentObservable()
	end)
	
	-- auto track
	local autoTrackButton = TRP3_DebuggerLandingPage.autoTrackActiveCampaignButton
	autoTrackButton.Text:SetText(L.AUTO_TRACK_LABEL)
	TRP3_API.ui.tooltip.setTooltipForSameFrame(autoTrackButton, "RIGHT", 0, 5, L.AUTO_TRACK_TT, L.AUTO_TRACK_DESC)
	autoTrackButton:SetScript("OnClick", function(self)
		storedData.autoTrack = self:GetChecked()
		if storedData.autoTrack then
			observation:StartSilent()
		end
	end)
	
	-- snapshot import tooltip
	TRP3_API.ui.tooltip.setTooltipForSameFrame(
		TotalRP3_Intended_InspectorAddSnapshotDialog.importFromStringButton, 
		"RIGHT", 
		0, 
		5, 
		L.POPUP_ADD_SNAPSHOT_IMPORT_BUTTON, 
		L.POPUP_ADD_SNAPSHOT_IMPORT_DESC
	)
	
	TRP3_API.events.listenToEvent(TRP3_API.events.WORKFLOW_ON_LOADED, function() 
	
		if not TRP3_Intended_Data then
			TRP3_Intended_Data = {}
		end
		storedData = TRP3_Intended_Data
	
		assert(TRP3_ToolFrame.actions.save and TRP3_ToolFrame.actions.save:GetScript("OnClick"), "TRP3_ToolFrame.actions.save has no OnClick handler yet")
		local save = TRP3_ToolFrame.actions.save:GetScript("OnClick")
		TRP3_ToolFrame.actions.save:SetScript("OnClick", function()
			save() -- also fires EVENT_REFRESH_CAMPAIGN
			observation:RefreshMenuItems()
		end)
		
		if TRP3_API.toolbar then
			local toolbarButton = {
				id = "hh_player_e_debugger",
				icon = "inv_inscription_pigment_bug04",
				configText = L.INSPECTOR_TOOLBAR_TEXT,
				tooltip = L.INSPECTOR_TOOLBAR_TT,
				tooltipSub = L.INSPECTOR_TOOLBAR_TT_DESC,
				onClick = function(self, _, buttonType, _)
					observation:ValidateObservables()
					TRP3_API.navigation.openMainFrame()
					if observation.currentObservable then
						TRP3_API.navigation.menu.selectMenu(observation.currentObservable.menuId)
					else
						TRP3_API.navigation.menu.selectMenu(MENU_ID_LANDING)
					end
				end,
				visible = 1
			}
			TRP3_API.toolbar.toolbarAddButton(toolbarButton)
		end
		
		for i=1, 17 do -- TRP3_API.inventory.onStart is only called onStart!
			assert(_G["TRP3_ContainerInvPageSlot" .. i], "TRP3_ContainerInvPageSlot" .. i .. " hasn't been created yet")
			hookContainerSlot(_G["TRP3_ContainerInvPageSlot" .. i])
		end
		
		autoTrackButton:SetChecked(storedData.autoTrack or false)
		
		if storedData.autoTrack then
			observation:StartSilent()
		end
		
		storedData.snapshots = storedData.snapshots or {}
		
	end)
	
	-- Add the Capture Effect
	
	TRP3_API.script.registerEffect(DEBUG_CAPTURE_POINT_ID, {
		method = function(structure, cArgs, eArgs)
			local captures = {}
			if eArgs.custom then
				for key, value in pairs(eArgs.custom) do
					tinsert(captures, {
						key = "|cff00ff00" .. key .. "|r",
						value = tostring(value)
					})
				end
			end		
			if cArgs[2] then
				for i = 1,#cArgs[2] do
					local capture = cArgs[2][i]
					if capture.taggedText then
						tinsert(captures, {
							key = capture.expressionText,
							value = TRP3_API.script.parseArgs(capture.taggedText, eArgs)
						})
					end
					if capture.operandId then
						local operand = TRP3_API.script.getOperand(capture.operandId)
						local code = "";
						if operand and operand.codeReplacement then
							code = operand:CodeReplacement(capture.arguments)
						end
						code = operandCode:format(code);
						for alias, global in pairs(operand.env) do
							code = IMPORT_PATTERN:format(alias, global) .. "\n" .. code;
						end
						local func, errorMessage = loadstring(code, "Generated operand code");
						if func then
							tinsert(captures, {
								key = capture.expressionText,
								value = func()(eArgs)
							})
						end
					end
					
				end
			end
			observation:AddCapture(cArgs[1] or "", eArgs.classID, eArgs.object, captures) -- captureId, fullId, object, variables
			observation:RefreshCurrentObservable()
		end,
		secured = TRP3_API.security.SECURITY_LEVEL.HIGH
	})
	
	local editor = TRP3_Intended_EffectDebugCapturePointEditor
	editor.capturePointIdEditBox.title:SetText(L.CAPTURES_ID_LABEL);
	TRP3_API.ui.tooltip.setTooltipForSameFrame(editor.capturePointIdEditBox.help, "RIGHT", 0, 5, L.CAPTURES_ID_LABEL, L.CAPTURES_ID_DESC);
	
	editor.table = TotalRP3_IntendedUI:CreateTable({
		parent = editor,
		top = 50,
		left = 300,
		height = 275,
		width = 275
	}, {}, {
		{name = "expressionText", type = "text", width = 100, grow = 1, shrink = 1, caption = L.CAPTURES_EXPRESSIONS},
		{
			type = "button", width = 16, template = "TRP3_Intended_CancelButtonTemplate", onClick = function(frame, index) 
				if index > 1 then
					tremove(frame:GetDataSource(), index)
					frame:Update(frame:GetDataSource())
				end
			end
		}
	})
	
	local function onOperandSelected(operandID, listbox)
		local operand = TRP3_API.extended.tools.getOperandEditorInfo(operandID) or TRP3_API.globals.empty;
		_G[listbox:GetName() .. "Text"]:SetText(operand.title or UNKNOWN);

		-- Show the editor, if any
		if editor.currentEditor then
			editor.currentEditor:Hide();
		end
		listbox.config:SetText(TRP3_API.loc.EFFECT_VAR_OPERAND_CONFIG_NO);
		if operand.editor then
			operand.editor:SetParent(editor.addCapturesOperand);
			operand.editor:ClearAllPoints();
			operand.editor:SetPoint("LEFT", 0, 0);
			operand.editor:SetPoint("RIGHT", 0, 0);
			operand.editor:SetPoint("BOTTOM", 0, 30);
			operand.editor:SetPoint("TOP", 0, -60);
			operand.editor.load();
			editor.currentEditor = operand.editor;
			operand.editor:Show();
			listbox.config:SetText(TRP3_API.loc.EFFECT_VAR_OPERAND_CONFIG);
		end
	end
	
	editor.addCapturesMain.operandButton:SetScript("OnClick", function()
		editor.addCapturesMain:Hide()
		editor.addCapturesOperand:Show()
		editor.addCapturesTaggedText:Hide()
		
		editor.addCapturesOperand.operandTypeSelect.selectedValue = "random"
		onOperandSelected(editor.addCapturesOperand.operandTypeSelect:GetSelectedValue(), editor.addCapturesOperand.operandTypeSelect)

		local operand = TRP3_API.extended.tools.getOperandEditorInfo(editor.addCapturesOperand.operandTypeSelect:GetSelectedValue()) or TRP3_API.globals.empty
		if operand.editor and operand.editor.load then
			operand.editor.load()
		end
		
	end)
	
	editor.addCapturesTaggedText.taggedTextEditBox.title:SetText(L.CAPTURES_TAGGED_TEXT_LABEL)
	TRP3_API.ui.tooltip.setTooltipForSameFrame(editor.addCapturesTaggedText.taggedTextEditBox.help, "RIGHT", 0, 5, L.CAPTURES_TAGGED_TEXT_TT, L.CAPTURES_TAGGED_TEXT_DESC);
	editor.addCapturesMain.taggedTextButton:SetScript("OnClick", function()
		editor.addCapturesMain:Hide()
		editor.addCapturesOperand:Hide()
		editor.addCapturesTaggedText.taggedTextEditBox:SetText("${event.1}")
		editor.addCapturesTaggedText:Show()
	end)
	editor.addCapturesOperand.cancelButton:SetScript("OnClick", function() 
		editor.addCapturesMain:Show()
		editor.addCapturesOperand:Hide()
	end)
	editor.addCapturesOperand.okButton:SetScript("OnClick", function() 
		local operandId = editor.addCapturesOperand.operandTypeSelect:GetSelectedValue()
		if operandId then
			local arguments
			local operand = TRP3_API.extended.tools.getOperandEditorInfo(operandId) or TRP3_API.globals.empty
			if operand.editor and operand.editor.save then
				arguments = operand.editor.save()
			end
			local text = operand.title or UNKNOWN;
			if operand.getText then
				text = operand.getText(arguments);
			end
			
			tinsert(editor.table:GetDataSource(), {expressionText = text, operandId = operandId, arguments = arguments})
			editor.table:Update(editor.table:GetDataSource())
		end
		editor.addCapturesMain:Show()
		editor.addCapturesOperand:Hide()
	end)
	
	
	editor.addCapturesTaggedText.cancelButton:SetScript("OnClick", function() 
		editor.addCapturesMain:Show()
		editor.addCapturesTaggedText:Hide()
	end)
	editor.addCapturesTaggedText.okButton:SetScript("OnClick", function() 
		local taggedText = editor.addCapturesTaggedText.taggedTextEditBox:GetText() or ""
		if taggedText ~= "" then
			tinsert(editor.table:GetDataSource(), {expressionText = taggedText, taggedText = taggedText})
			editor.table:Update(editor.table:GetDataSource())
			editor.addCapturesMain:Show()
			editor.addCapturesTaggedText:Hide()
		end
	end)

	
	function editor.load(scriptData)
		editor.capturePointIdEditBox:SetText(scriptData.args and scriptData.args[1] or "");
		editor.addCapturesMain:Show()
		editor.addCapturesOperand:Hide()
		editor.addCapturesTaggedText:Hide()
		editor.table:Update(scriptData.args and scriptData.args[2] or {{expressionText = L.CAPTURES_ALL_WORKFLOW_VARS}})
		
		local structure = {};
		TRP3_API.extended.tools.getEvaluatedOperands(structure);
		TRP3_API.ui.listbox.setupListBox(editor.addCapturesOperand.operandTypeSelect, structure, onOperandSelected, nil, 255, true);
		
	end

	function editor.save(scriptData)
		scriptData.args[1] = strtrim(editor.capturePointIdEditBox:GetText());
		scriptData.args[2] = editor.table:GetDataSource()
	end
	
	TRP3_API.extended.tools.registerEffectEditor(DEBUG_CAPTURE_POINT_ID, {
		title = L.CAPTURES_EFFECT_LABEL,
		icon = "inv_pet_achievement_captureawildpet",
		description = L.CAPTURES_EFFECT_TT,
		effectFrameDecorator = function(scriptStepFrame, args)
			scriptStepFrame.description:SetText(L.CAPTURES_EFFECT_PREVIEW:format(args[1] or ""))
		end,
		getDefaultArgs = function()
			return {
				TRP3_ScriptEditorNormal.workflowID,
				{{expressionText = L.CAPTURES_ALL_WORKFLOW_VARS}}
			}
		end,
		editor = editor
	})
	
	--[[ -- this is the ugly button that was added to the UI previously, now the effect is properly put into the effects menu
	local capturePointButton = CreateFrame("Button", nil, TRP3_ScriptEditorNormalWorkflowContainer, "UIPanelButtonTemplate")
	capturePointButton:SetSize(140, 22)
	capturePointButton:SetText(L.CAPTURES_ADD_BUTTON_LABEL)
	capturePointButton:SetPoint("LEFT", TRP3_ScriptEditorNormalWorkflowContainer.add, "RIGHT", 10, 0)
	capturePointButton:SetScript("OnClick", function() 
		local data = TRP3_ToolFrame.specificDraft.SC[TRP3_ScriptEditorNormal.workflowID].ST
		data[tostring(TRP3_ScriptEditorNormal.list.size + 1)] =  {
			t = TRP3_DB.elementTypes.EFFECT,
			e = {
				{
					id = DEBUG_CAPTURE_POINT_ID,
					args = {TRP3_ScriptEditorNormal.workflowID, {{expressionText = L.CAPTURES_ALL_WORKFLOW_VARS}}}
				}
			}
		}
		TRP3_ScriptEditorNormal.list.refreshElementList()
	end)
	capturePointButton:SetScript("OnEnter", function(self) 
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:SetText(L.CAPTURES_ADD_BUTTON_DESC, nil, nil, nil, nil, true)
		GameTooltip:Show()
	end)
	capturePointButton:SetScript("OnLeave", function(self) 
		if GameTooltip:GetOwner() == self then
			GameTooltip:Hide()
		end
	end)
	--]]
end

TRP3_API.globals.intended_display_version = GetAddOnMetadata(addonName, "Version")

TRP3_API.module.registerModule({
	["name"] = "Intended",
	["description"] = L.MODULE_DESC,
	["version"] = tonumber(GetAddOnMetadata(addonName, "X-Build")),
	["id"] = "trp3_intended",
	["onInit"] = onInit,
	["onStart"] = onStart,
	["minVersion"] = 87,
	["requiredDeps"] = {
		{"trp3_extended", TRP3_API.globals.extended_version},
		{"trp3_extended_tools", TRP3_API.globals.extended_version},
	}
})
